#!/usr/bin/python

#Crucial Questions Better BBS 
#Copyright 2000 Hans Joseph Solbrig
#
#See License Agreement in distribution

import os
import stat
import dircache
import regex
import regsub
import string
import copy
import profile
import pickle
import sys
import traceback
import pdb
import types


import Prod
import MyUtil
import HtmlBlock
import MyAdmin
import MyControl

"""
import MyToken
import MySerialNumber
import Mycgi #cgi tweeked for non-unix systems
import MyControl
import MyUtil
import ProdItterate
import Prod
import MyAdmin
"""



#Fields
# CommandString

#List of file names and dependency dates.

class CacheFileSpec:
	def __init__(self, 
			cachedFileName = "", 
			fileList = [],
			fileDate = - 1):
		self.cachedFileName = cachedFileName 
		self.fileList  = fileList 
		self.fileDate = fileDate 
		#Might not actually be needed.

##Two different approach
##Reconstituted

class FileProcessor:
	CacheDictionary = None
	filePointer = None
	bbsFileStart = 'BBScache'
	maxFileNum = 0
	
	def __init__(self):
		if FileProcessor.CacheDictionary is None:
			try:
				try:
					FileProcessor.filePointer = open(
						MyUtil.AdjustPath("fileCache.bin"),'r')
					u = pickle.Unpickler(FileProcessor.filePointer)
					FileProcessor.CacheDictionary = u.load()
				finally:
					if FileProcessor.filePointer is not None:
						FileProcessor.filePointer.close()
						FileProcessor.filePointer = None
			except:
				FileProcessor.CacheDictionary = {} 
		
	def __del__(self):
		
		if FileProcessor.CacheDictionary is not None:
			if FileProcessor.filePointer is None:
				FileProcessor.filePointer = open(MyUtil.AdjustPath("fileCache.bin"),'w')
			
			p = pickle.Pickler(FileProcessor.filePointer)
			p.dump(FileProcessor.CacheDictionary)
			FileProcessor.filePointer.close()
			FileProcessor.filePointer = None
			FileProcessor.CacheDictionary = None
		
	def CloseUp(self):
		if FileProcessor.CacheDictionary is not None:
			if FileProcessor.filePointer is None:
				FileProcessor.filePointer = open(MyUtil.AdjustPath("fileCache.bin"),'w')
			
			p = pickle.Pickler(FileProcessor.filePointer)
			p.dump(FileProcessor.CacheDictionary)
			FileProcessor.filePointer.close()
			FileProcessor.filePointer = None
			FileProcessor.CacheDictionary = None
	
	def NextFileName(self):	
		for k in FileProcessor.CacheDictionary.keys():
			numStr = (
				FileProcessor.CacheDictionary[k].cachedFileName
					)[len(FileProcessor.bbsFileStart):]
			numStr = numStr[-4:]
			if MyUtil.IsStringNumber(numStr):
				fileNum = string.atoi(numStr)
				if fileNum > FileProcessor.maxFileNum:
					FileProcessor.maxFileNum = fileNum
			else: 
				FileProcessor.maxFileNum = \
					FileProcessor.maxFileNum + 2
		return FileProcessor.bbsFileStart + (
			'%d' % (FileProcessor.maxFileNum + 3)) + '.bin'

	#time.asctime(time.gmtime(os.stat("base.bbs")[stat.ST_MTIME]))
	def ProcessCommand(self, commandString):
		isCached = 0
		#pdb.Pdb().set_trace()
		if FileProcessor.CacheDictionary.has_key(commandString):
			fileProcKey = FileProcessor.CacheDictionary[commandString]
			theFileList = fileProcKey.fileList
			isCached = 1
			
			#check to see if the file has been modified. 
			for y in theFileList:
				try: 
					st = os.stat(y)
				except:
					continue
				
				mtime = st[stat.ST_MTIME]
				if mtime > fileProcKey.fileDate:
					isCached = 0
					break
					
		if isCached:
	
			UserFile = FileProcessor.CacheDictionary[
				commandString].cachedFileName
			MyUtil.DebugOut('Using cached File: ')
			MyUtil.DebugOut(commandString + '+ ')
			MyUtil.DebugOut(UserFile)
			#try:
			fp = open(MyUtil.AdjustPath(UserFile )) 
			print "Content-type: text/html"
			print
			print	
			resString = fp.read(-1)
			print resString 
			return
			#except:
			#	MyUtil.errorLog.append('failed to find cached file' 
			#			+ commandString)
			
		resString = MyControl.action(commandString)
		print "Content-type: text/html"
		print	
		print

		if FileProcessor.CacheDictionary.has_key(commandString):
			theFileName = FileProcessor.CacheDictionary[
				commandString].cachedFileName
		else:
			theFileName  = self.NextFileName()
		newFp = open(MyUtil.AdjustPath(theFileName), 'w')
		newFp.write(resString)
		newFp.close()
		newStat = os.stat(theFileName)
		newTime = newStat[stat.ST_MTIME]

		FileProcessor.CacheDictionary[commandString] = \
			CacheFileSpec(theFileName,
				Prod.ProdList.allProdFiles,
				newTime)
		
		FileProcessor.CacheDictionary[commandString].fileList = \
			Prod.ProdList.allProdFiles
		
		print resString 
			
	def ProcessCGI(self,testForm = None,testString = None):
		loader = MyControl.pageLoader()
		if testString is None:
			res = loader.ShowPage(1)
		else:
			res = loader.ShowPage(1,testForm,testString)
		MyControl.printErrorlog()
			
		#Now mark files dirty
		changedFiles = Prod.ProdList.allProdFiles
		for x in FileProcessor.CacheDictionary.keys():
			for y in FileProcessor.CacheDictionary[x].fileList:
				if y in changedFiles:
					del FileProcessor.CacheDictionary[x]
					break

		return res
		

def doCGI(testForm = None, testString = None):
	FP = FileProcessor()
	res = FP.ProcessCGI(testForm,testString)
	return res

def doMain(testString = None):
	myArgs = ''
	glob = None
	try:
		try:
			glob = MyUtil.outFile()
			if testString is None:
				if len(sys.argv) > 1:
					myArgs = sys.argv[1]
				else:
					myArgs = ''
			else: 
				myArgs = testString
				
			FP = FileProcessor()
			FP.ProcessCommand(myArgs)
			FP.CloseUp()
		finally:
			del glob
	except: 
		print '-'*10
		errorlist = traceback.format_list(
			traceback.extract_tb(sys.exc_info()[2]))
		print 'printing error:'
		for x in errorlist:
			print '<p>'
			print x
			print '</p>'
		errorlist = traceback.format_list(
			traceback.extract_tb(sys.exc_info()[2]))
		print 'printing the exception:'
		print sys.exc_info()[0]
		print sys.exc_info()[1]
		print 'end printing error:'

		"""
		stackFP = open(MyUtil.AdjustPath("except.out"),'w')
		traceback.print_exc(None,stackFP)
		stackFP.close()
		print "Content-type: text/html"
		print	
		print	
		print "BBS code error, press back button"
		"""

def main():
	doMain()			
	
if __name__ == '__main__':
	main()


