
#Mult-Pre-processor for server-side tags

#Crucial Questions Better BBS 
#Copyright 2000 Hans Joseph Solbrig
#
#See License Agreement in distribution

import pdb
import re
import sys
import string
import sgmllib
import htmllib
from sgmllib import SGMLParser
from htmllib import HTMLParser

import Prod #must be first
import Production
import ProdItterate
import MySerialNumber
import MyToken
import MyUtil

maxTextLength = 600

#The structure [tag,attr,isEnd] simplifies our treatment of tags

paragraphTags = ['H1','H2','H3','H4','H5','H6',
                 'H7','H8','H9','p','b','i','u','font']

normalParagraphTags = ['p','b','i','u','font']

def PrintEnd(tagStack):
    resStr = ""
    for x in tagStack:
        if x.tag in paragraphTags:
            resStr =  resStr  + x.__str__(1)
    return resStr

def PrintStart(tagStack):
    resStr = ""
    for x in tagStack:
        if x.tag in paragraphTags:
            resStr =  resStr  + x.__str__()
    return resStr

class TagClass:
    def __init__(self,tag,attr = None,isEnd = 0):
        self.tag = tag
        self.attr = attr
        self.isEnd = isEnd
        self.scanning = 1

    def __str__(self,showEnd = 0):
        if (not self.isEnd) and (not showEnd):
            tagStr = '<' + self.tag
            if self.attr:
                for name, value in self.attr:
                    tagStr = tagStr + ' ' + name + '=' + '"' + value + '"'
            tagStr = tagStr + '>'
            return tagStr
        else:
            return '</' + self.tag + ' >'
            
class ProdAccumulator:
    def __init__(self,
                 baseToken,
                 parentProcessor):
        self.parentProcessor = parentProcessor
        self.scratchData = ""
        self.ProdTokenList = []
        self.baseToken = baseToken

    def AddData(self,toAdd,count = 0, tag = None):
        if type(toAdd) == type(""):
            addStr = toAdd
        else:
            addStr = toAdd.__str__()
        self.scratchData = self.scratchData + addStr
        self.parentProcessor.outText = self.parentProcessor.outText + addStr
            
    def SetBaseToken(self, theToken):
        self.baseToken = theToken
        
    def FinishToken(self,toFinish = "", returnType = 'terminal'):
        if type(toFinish) == type(""):
            self.scratchData = self.scratchData + toFinish

        if len(self.scratchData) > 0:
            self.ProdTokenList.append(MyToken.Token(self.scratchData,returnType))

        if type(toFinish) != type(""):
            self.ProdTokenList.append(toFinish)
        self.scratchData = ""

    def FinishProd(self):
        self.FinishToken()
        self.ProdTokenList = [self.baseToken] + self.ProdTokenList
        theProd = Production.Production(self.ProdTokenList)
        self.ProdTokenList = []
        return theProd 



#Our basic assumption is a break must between N and N X 3 characters
#in length.
#
#We should be keeping Two breakes in our pocket so we can make sure
#that things stay even
#
class BreakingAccumulator(ProdAccumulator):
        
    def __init__(self,
                 baseToken,
                 parentProcessor,
                 baseTag = None):
        self.baseText = HtmlTextImp()#baseToken,parentProcessor
        self.textRecentlyInserted = 0
        self.accumulatingTokens = []

        self.lastNorPar = self.baseText.At()
        self.lastGenPar = self.baseText.At()
        self.lastTextBreak = self.baseText.At()
        self.sentenceBreakMark = self.baseText.At()

        ProdAccumulator.__init__(self,baseToken,parentProcessor)
        if baseTag is not None:
            self.parentProcessor.outText = self.parentProcessor.outText + \
                baseTag.__str__()
        self.baseTag = baseTag
        
    def ProcessText(self, finish = 0):
        #assert(self.scratchData !="")
        bookMark = self.baseText.At()
        self.baseText.AddData(self.scratchData)
        newPosition = self.baseText.At()
        breakText = None
        toAdd = self.scratchData
            
        self.textRecentlyInsert = 1
        for i in range(min(len(toAdd),maxTextLength)):
            if toAdd[i] == '\n':
                self.lastTextBreak = bookMark.At(i)
            if toAdd[i:i+2] == '. ' and (i+2 < len(toAdd)):
                self.sentenceBreakMark = bookMark.At(i)
                
        if ((newPosition.cDataCount > maxTextLength)
            or finish ):

            if self.lastNorPar.cDataCount > maxTextLength/6:
                breakText = self.baseText.TruncateBy(self.lastNorPar )
            elif self.lastGenPar.cDataCount > maxTextLength/6:
                breakText = self.baseText.TruncateBy(self.lastGenPar )
            elif self.lastTextBreak.cDataCount > maxTextLength/4:
                breakText = self.baseText.TruncateBy(self.lastTextBreak)
            elif self.sentenceBreakMark.cDataCount > maxTextLength/4:
                breakText = self.baseText.TruncateBy(self.sentenceBreakMark)
            else:
                diff = max(0, maxTextLength - bookMark.cDataCount)
                lastCharBreak = bookMark.At(diff)
                breakText = self.baseText.TruncateBy(lastCharBreak)

            if breakText is not None:
                theNewBase = MyToken.Token(self.baseToken.ToBaseString(),'nt',
                    Prod.ProdList().NextSerialNumBelow(
                        ProdItterate.ItemCopy(self.baseToken.serialNum)))
                resProd = Production.Production([theNewBase]+
                    self.accumulatingTokens +
                    [MyToken.Token(breakText)])
                self.accumulatingTokens = []
                self.parentProcessor.finalProdList.append(resProd)
                if not self.parentProcessor.breakingStream:
                    resProd.containerFile = theFileName 
                    Prod.ProdList().AddProd(resProd)
                else:
                    self.parentProcessor.finalBlocks.append(breakText)

                if resProd is not None:
                    self.parentProcessor.outText = self.parentProcessor.outText \
                                           + resProd.AsHtmlFragment()

                self.lastNorPar = HtmlTextImp(characters = None)
                self.lastGenPar = HtmlTextImp(characters = None)
                self.lastTextBreak = HtmlTextImp(characters = None)
                self.sentenceBreakMark = HtmlTextImp(characters = None)
        self.scratchData = ""

    def AddData(self,toAdd):
        bookMark = self.baseText.At()
        if type(toAdd) == type(""):
            self.textRecentlyInserted = 1
            self.scratchData = self.scratchData + toAdd
              
            if (bookMark.cDataCount +len(self.scratchData)
                  > maxTextLength):
                self.ProcessText()
        else:
            if self.scratchData != "":
                self.ProcessText()
            if ((self.parentProcessor.breakTextTagList is None)
                or toAdd.tag in self.parentProcessor.breakTextTagList):
                self.baseText.AddData(toAdd)

            #Test for break even if we scan out the tag
            newPosition = self.baseText.At()
            #Tag text case(s)
            if self.textRecentlyInserted:
                self.textRecentlyInserted = 0
                if toAdd.tag in paragraphTags:
                    self.lastGenPar = bookMark.At()
                    if toAdd.tag in normalParagraphTags:
                        self.lastNorPar = bookMark.At()
                        #Pop tag since mark is before the tag
                        #self.lastGenPar.tagStack = self.lastGenPar.tagStack[0:-1]

    def FinishToken(self,toFinish = "",returnType = 'terminal'):
        if self.scratchData != "":
            self.ProcessText()

        if self.baseText.cDataCount > 0:
            breakText = self.baseText.TruncateBy(self.baseText.At())
            self.accumulatingTokens.append(MyToken.Token(breakText))
        if toFinish != "":
            toFinish.tokenType = returnType
            self.accumulatingTokens.append(toFinish)

    def FinishProd(self):
        #breakText = self.baseText.TruncateBy(self.baseText.At())
        self.ProcessText(1)
        while self.baseText.cDataCount > 0 :
            self.ProcessText(1)
        if self.baseTag:
            self.parentProcessor.outText = self.parentProcessor.outText \
                                   + self.baseTag.__str__(1)
        ProdAccumulator.FinishProd(self)
        return None


#Helper class for breaking accumulator    
class HtmlTextImp:
    def __init__(self,
                 charsCount = 0,
                 cDataCount = 0,
                 tagStack = [],
                 characters = "" ):
        self.charsCount = charsCount
        self.cDataCount = cDataCount
        self.tagStack = tagStack
        self.characters = characters 


    def AddData(self, toAdd):
        if type(toAdd) == type(""):
            self.charsCount = self.charsCount + len(toAdd)
            self.cDataCount = self.cDataCount + len(toAdd)
            self.characters = self.characters + toAdd
        else:
            tagStr = toAdd.__str__()
            self.charsCount = self.charsCount + len(tagStr)
            self.characters = self.characters + tagStr
            if not toAdd.isEnd:
                self.tagStack.append(toAdd)
            else:
                found = -1
                for i in range(len(self.tagStack)):
                    if self.tagStack[i].tag == toAdd.tag: found = i
                if found > -1:
                    del self.tagStack[i]

    def At(self,index = 0, beforeTag = 0):
        newStack = []
        for x in self.tagStack[0:-1]:
            newStack.append(x)
        location = HtmlTextImp(self.charsCount + index,
                                    self.cDataCount+ index,newStack)
        location.characters = None
        return location
    
    def TruncateBy(self, textBookMark):
        returnText = self.characters[:textBookMark.charsCount] + \
                     PrintEnd(textBookMark.tagStack)
        
        BeginChars = PrintStart(textBookMark.tagStack)
        self.characters = BeginChars + self.characters[textBookMark.charsCount:]
        
        self.charsCount = len(self.characters)  
        self.cDataCount = self.cDataCount - textBookMark.cDataCount 

        return returnText 

class HTMLTextProcessor(SGMLParser):
    def __init__(self,
        baseToken = None,
        verbose=0, breakingStream = 0,
        breakTextTagList = None):
        self.breakingStream = breakingStream 
        if self.breakingStream:
            self.accumList = [BreakingAccumulator(baseToken,self)]
        else:
            self.accumList = [ProdAccumulator(baseToken,self)]
            
        self.baseFileTagged = 0
        self.outText = ""
        self.finalProdList = []
        self.textForBreaking = ""
        self.gettingStaticData = 0
        self.breakTextTagList = breakTextTagList 
        self.finalBlocks = []
        self.scanning = 1
        self.theBaseProd = None
        self.baseProdBookMark = 0
        self.baseMark = 0
        SGMLParser.__init__(self, verbose)

    def feed(self, data):
        extra = data
        while 1:
            l = maxTextLength/4
            theData = extra[:l]
            extra = extra[l:]
            if len(theData) == 0:
                break
            SGMLParser.feed(self, theData)

    def CurrentBaseToken(self):
        return ProdItterate.ItemCopy(self.accumList[-1].baseToken)
    

    def CurrentBaseSerialNum(self):
        return ProdItterate.ItemCopy(self.accumList[-1].baseToken.serialNum)

    def AddData(self,text):
        self.accumList[-1].AddData(text)

    def FinishToken(self,toFinish = "",returnType = 'terminal'):
        self.accumList[-1].FinishToken(toFinish,returnType)

    def BeginSubProduction(self,baseProdToken,baseTag = None):
        if self.gettingStaticData:
            self.accumList.append(BreakingAccumulator(baseProdToken,self, baseTag))
        else:
            self.accumList.append(ProdAccumulator(baseProdToken,self))
        

    def FinishProduction(self):
        theProd = self.accumList[-1].FinishProd()
        if theProd is not None:
            self.finalProdList.append(theProd)
        if len(self.accumList) == 1:
            self.theBaseProd = theProd
        self.accumList = self.accumList[0:-1]

    #Data Handlers -------------------
    def handle_data(self, data):
        if not self.scanning:
            return
        self.AddData(data)
    def handle_comment(self, data):
        self.AddData('<!---' + data + '--->')

    #If we used 'start_' + bbsSubstituteTag, we wouldn't
    #be able to easily rename bbsSubstituteTag - and that's important
    #
    #(Any system based on generated function names actually is BAD.
    #You create really obscure couplings - when you want make code
    #as loosely coupled as possible.
    #Really there's a better way to do things.)
    #
    #Instead, everything will be in unknown_starttag and unknown_endtag

    def addProdBase(self):
        self.baseProdBookMark = len(self.outText)

    #This skim off everything except stuff in the body
    def unknown_starttag(self, tag, attrs):
        if tag == 'head':
            self.addProdBase()
            self.scanning = 0
        if not self.scanning: return
        if tag == 'html': 
            self.addProdBase()
            return
        
        if tag == 'body':
            self.addProdBase()
            return
        tagCl = TagClass(tag,attrs)
        newBaseToken = None
        newSerialNum = None
        
        
        if tag == MyUtil.bbsSubstituteTag:
            self.FinishToken()
            for name, value in attrs:
                if name == MyUtil.ProdBaseTokenName:
                    self.FinishToken(MyToken.Token(value,'nt'))
            return

        elif tag == MyUtil.bbsProdNameTag:
            if not self.baseMark:
                self.baseMark = 1
                newSerialNum = None
                for name, value in attrs:
                    if name == MyUtil.ProdBaseTokenName:
                        newKey = value
                    if name == MyUtil.ProdBaseSerialNumName:
                        newSerialNum = MySerialNumber.DecQuantity(
                            ).ParseSerialNum(value)
                self.accumList[-1].SetBaseToken(
                        MyToken.Token(value,'nt',newSerialNum ))
                if len(self.accumList) == 1:
                    self.baseFileTagged = 1
            return

        elif tag == MyUtil.bbsEmbedProdSequenceTag:
            self.FinishToken()
            self.gettingStaticData = 1
            self.EmbedToken(attrs,self.CurrentBaseToken(),tagCl)
            return

        #elif tag == bbsEmbedProdSubSequenceTag:
        #    self.FinishToken()
        #    self.EmbedToken(attrs)
        #    return
            
        elif tag == MyUtil.bbsEmbedProdTag:
            self.FinishToken()
            self.EmbedToken(attrs)
            return

        for name, value in attrs:
            if name == MyUtil.bbsAttrSubstituteTag:
                subFound = 1
                tokenString = '*tagas*' + tag
                if value[0] != '*':
                    value = '*' + value
                tokenString = tokenString + value
                self.FinishToken(MyToken.Token(tokenString,'nt') )
                return
        
        self.AddData(tagCl)

    def EmbedToken(self,attrs, defaultBaseToken = None,baseTag = None):
            newBaseToken = defaultBaseToken 
            newSerialNum = None
            for name, value in attrs:
                if name == MyUtil.ProdBaseTokenName:
                    newBaseToken = MyToken.Token(value,'nt')
                if name == MyUtil.ProdBaseSerialNumName:
                    newSerialNum = MySerialNumber.DecQuantity(
                        ).ParseSerialNum(value)
    
            if newBaseToken is not None:
                if newSerialNum is not None:
                    newBaseToken.serialNumber = newSerialNum 
                self.FinishToken(newBaseToken)
                self.BeginSubProduction(newBaseToken,baseTag)


    def unknown_endtag(self, tag):
        if tag == 'head':
            self.scanning = 1
            return

        if not self.scanning:
            return

        if tag == 'html':
            return

        #pdb.Pdb().set_trace()
        if tag in MyUtil.AllProdTags:
            if len(self.accumList) > 0:
                self.FinishProduction()
        else:
            tagCl = TagClass(tag,None,1)
            self.AddData(tagCl)
            
    def unknown_entityref(self, ref):
        self.AddData('&' + ref + ';' )
    def unknown_charref(self, ref):
        self.AddData('&#' + ref + ';')

    def close(self):
        SGMLParser.close(self)
        while len(self.accumList) > 0:
            self.FinishProduction()
        if not self.baseMark and self.theBaseProd:
            self.outText = self.outText[:self.baseProdBookMark] \
                    + self.theBaseProd.KeyAsTag() \
                    + self.outText[self.baseProdBookMark:]

def BreakTextString(TextString, isHtml = 0):
    if isHtml:
        theBreakTextTagList = paragraphTags 
    else:
        theBreakTextTagList = ['p']
    processor = HTMLTextProcessor(
            MyToken.Token('S','nt'),
            breakingStream = 1,
            breakTextTagList = theBreakTextTagList)
    processor.feed( TextString)
    processor.close()
    return processor.finalBlocks
    

global theFileName
theFileName = ''

def ProdFromFile(fileName,
                 prodKey = 'ViewType',
                 baseSerialNum = None,
                 replaceOrig = 1 ):
    theFileName = fileName
    f = open(fileName, 'r')
    data = f.read(-1)
    f.close()
    
    if replaceOrig:
        bakFile = fileName + '.bbk'
        replaceFP = open(fileName,'w')
        bakFP = open(bakFile,'w')
        bakFP.write(data)
        bakFP.close()
    
    processor = HTMLTextProcessor(
            MyToken.Token(prodKey, 'nt', baseSerialNum))
    processor.feed( data )
    processor.close()
    
    mainProd = processor.theBaseProd
    if mainProd.ItsSerialNum() is None:
        mainProd.SetSerialNum(baseSerialNum)
    
    if replaceOrig and processor.baseFileTagged:
        replaceFP.write(processor.outText)
        replaceFP.close()
        
    for x in processor.finalProdList:
        x.containerFile = theFileName 
        Prod.ProdList().AddProd(x)
    
    return mainProd 


def main():
    args = sys.argv[1:]
    if args:
        file = args[0]
    else:
        file = 'base.html'
    try:
        f = open(file, 'r')
    except IOError, msg:
        print file, ":", msg
        sys.exit(1)
        
    outFile = file + 's'
    try:
        outFP = open(outFile,'w')
    except IOError, msg:
        print file, ":", msg
        sys.exit(1)

    data = f.read()
    processor = HTMLTextProcessor(MyToken.Token('S','nt',
            MySerialNumber.DecQuantity('0')))
    processor.feed(data )
    processor.close()
    outFP.write(processor.outText)
    outFP.close()
    
    ##Testing still
    for y in processor.finalProdList:
        print y.__str__()


def test(args = None):
    import sys
    if not args:
        args = sys.argv[1:]
    if args:
        file = args[0]
    else:
        file = 'base.html'
        f = open(file, 'r')
    data = f.read()

    x = HTMLTextProcessor(MyToken.Token('S','nt'))
    for c in data:
        x.feed(c)
    x.close()
    
    for y in x.finalProdList:
        print y.__str__()

def test2(args = None):
    import sys
    if not args:
        args = sys.argv[1:]
    if args:
        file = args[0]
    else:
        file = 'base.html'
        f = open(file, 'r')
    data = f.read()
    theArray = BreakTextString(data)
    
    for y in theArray:
        print y
        print '-------->-break-line-<----------'

if __name__ == '__main__':
    test2()
