#!/usr/bin/python

#Crucial Questions Better BBS 
#Copyright 2000 Hans Joseph Solbrig
#
#See License Agreement in distribution

#This file actually controls actions within the system,
#It is called indirectly through cgi scripts or links

import os
import dircache
import cgi
import Mycgi 
import sys
import regex
import regsub
import string
import profile
import copy
import traceback
import re
import pdb

import Prod
import MyUtil
import HtmlBlock
import MyAdmin

#fudge to allow running test system under windows

class MyFieldType(cgi.FieldStorage):
	def make_file(self, binary):
		#Create a temporary file 
		#for reading and writing,
		#we need a binary and one non-binary
		if os.name == 'nt':
			if binary == "":
				f = open("cgi_temp.tmp", "w%s+" % binary)
			else:
				f = open("cgi_bin.tmp", "w%s+" % binary)
			return f
		else:
			cgi.FieldStorage.make_file(self, binary)
		
	#Later we might want to delete this when we're done
	#But 'nt' is just test anyway
	#
	#def __del__():
	#	MyTempFile.close(); 
	

#Controls the entire system
class pageLoader:
	theForm = {}
	isCgi = 0
	outForm = {}
	
	def __init__(self):
		self.test = 0
		self.specialCommandLine = 0 
		self.ServedFilePath = None
		self.prodsToWrite = None

	def ShowPage(self,
		startedWithCgi = 0,
		testForm = None,
		testString = None,
		isCommand = 0):
		self.specialCommandLine = isCommand
		if testString is not None:
			self.myArgs = ""
			for x in testString:
				if x != '\\':
					self.myArgs = self.myArgs + x
		elif len(sys.argv[1:]) > 0:
			self.myArgs = ''
			for y in sys.argv[1:]:
				for x in y:
					if x != '\\':
						self.myArgs = self.myArgs + x
		else:
			self.myArgs = None
		
		if self.myArgs:
			self.myArgs = string.strip(self.myArgs)
			if self.myArgs[0] != '[':
				self.ServedFilePath = self.myArgs
				self.myArgs = None
			else:
				self.myArgs = MyUtil.UnMangleString(
								self.myArgs)
		if testForm is not None:
			pageLoader.isCgi = 1
			pageLoader.theForm = testForm
		
		elif startedWithCgi:
			pageLoader.isCgi = 1
			pageLoader.theForm = MyFieldType()
		
		self.ReformatCGI()
		baseList = Prod.ProdList()
		baseList.LoadProd()
		baseList.LoadProd('posts.bbs')
		baseList.LoadGeneratedProds()
		if self.ServedFilePath and not self.specialCommandLine:
			self.myArgs = self.LoadFileArg()
		
		##Do userDynamicProduction last so they pre-empt other commands
		if self.myArgs is not None:
			baseList.LoadProd(Prod.TextView(self.myArgs))
		
			#Clean-up the index of prods 
			baseList.ModifyValues()
		
		if self.specialCommandLine == 0:
			res = baseList.ExpandToView()
			baseList.WriteFiles()
		else:
			res = self.WriteProdAsFile(baseList)
		
		Prod.ProdList().Cleanup()
		MyAdmin.UserList().Cleanup()
		return res

	def LoadFileArg(self):
		prodSerialNum = Prod.minProdList.FileSerialNumber(
			self.ServedFilePath)
		#This is a production created for just this session
		fileProd = HtmlBlock.ProdFromFile(self.ServedFilePath,
			Prod.ProdList.fileProdKey)
		fileProd.containerFile = self.ServedFilePath

		Prod.minProdList.AddProd(fileProd)
		#Since parsing can change anything
		ProdKey = fileProd.ItsKey()
		prodSerialNum = fileProd.ItsSerialNum()
		return ('[*S,[ViewType,'+ ProdKey
				+ '],[BaseSerialNumber,#'
				+ prodSerialNum.__str__()+ ']]')

	def WriteProdAsFile(self,baseList):
		for x in self.prodsToWrite:
			AProd = baseList.ProdFromKey(x)
			theString = AProd.AsHtmlStream(asBase = 1)
			outFP = open(x + '.prd','w')
			outFP.write(theString)
			outFP.close()
			print x + ' written To File'


	def ReformatCGI(self):
		if pageLoader.isCgi:
			for x in pageLoader.theForm.keys():
				finalKey = string.upper(x)
				finalKey = string.strip(finalKey)
				pageLoader.outForm[finalKey] =  \
					pageLoader.theForm[x].value
		
	def CGISelectList(self, theString):
		accumulator = []
		theString = string.upper(theString)
		for x in pageLoader.outForm.keys():
			if ((theString == x[:len(theString)])
				and pageLoader.outForm[x] == 'YES'):
				accumulator.append(x[len(theString):])

		if len(accumulator) > 0:
			return accumulator
		else:
			return None
			
	def IsCGIValue(self,theKey):
		if pageLoader.isCgi:
			theKey = string.upper(theKey)
			return pageLoader.outForm.has_key(theKey)
		return 0 
		
	def CgiValue(self,theKey):
		if pageLoader.isCgi:
			theKey = string.upper(theKey)
			theKey = string.strip(theKey)
			if pageLoader.outForm.has_key(
					string.upper(theKey)):
				return pageLoader.outForm[string.upper(theKey)]
		return ''

	def CgiHtmlBlockList(self,blockKey, isHtml = 0):
		if pageLoader.isCgi:
			if pageLoader.outForm.has_key(
				string.upper(blockKey)):
				toBreak = \
					pageLoader.outForm[
						string.upper(blockKey)]
			else: return []
		else: return []
		MyUtil.DebugOut(toBreak)

		if 1:
			toBreak = '<p>' + toBreak +'</p>'
			if '\n' in 	toBreak:
				toBreak = re.sub('\n','#-#&#',toBreak )
				toBreak = re.sub('\r','',toBreak )
				MyUtil.DebugOut(toBreak)
				toBreak = re.sub('#-#&##-#&#','<p></p>',toBreak )
				MyUtil.DebugOut(toBreak)
				toBreak = re.sub('#-#&#',' ',toBreak )
				MyUtil.DebugOut(toBreak)

		return HtmlBlock.BreakTextString(toBreak,
								isHtml = isHtml)


#Called by the profile module
def test():
	MyUtil.outFile.isDebugTracing = 0
	str = action(" [*S,[ViewType,TextView],[PostSerialNum,0;1;3]]")
	#str = action()
	print str

def action(testArg = None, isCommand= 0,
		prodsToWrite = None):
	loader = pageLoader()
	loader.prodsToWrite  = prodsToWrite 
	res = loader.ShowPage(0,
				testForm = None,
				testString = testArg,
				isCommand = isCommand)
	printErrorlog()
	return res

def printErrorlog():
	fp = open("errorLog.out",'w')
	if fp is not None:
		for x in MyUtil.errorLog:
			if type(x) == type(''):
				fp.write(x)
				fp.write('\n')
			else:
				fp.write("Error in errorlog")
				fp.write('\n')
	fp.close()


#a seperate file is used to load cgi
def main():
	#MyUtil.outFile.isDebugTracing = 1
	try:
		try:
			glob = MyUtil.outFile()
			res = action()
			print "Content-type: text/html"
			print	
			print res
		finally:
			del glob
	except: 
		
		stackFP = open("except.out",'w+')
		traceback.print_exc(None,
				stackFP)
		
		stackFP.close()
		print "Content-type: text/html"
		print	
		print "BBS code error, press back button"

if __name__ == '__main__':
	main()




