#Crucial Questions Better BBS 
#Copyright 1998-1999 

#These classes read, interpret, add and write 
#'productions'

import os
import stat
import glob
import regex
import regsub
import string
import copy
import pdb
import profile
import pickle
import types

import ProdItterate
import MyToken
import MyUtil
import MySerialNumber
import SerialNumList
import GenericCache
import Production
import HtmlBlock



global UserOptionsText
UserOptionsText = ''

TextViewError = 'TextViewError'
RecursionException = 'Recursion Error'

class TextView:
	def __init__(self,body="",count=0):
		keyNum = 0
		if(type(body) == type("")):
			self.textBody = body
			self.textCount = count
			self.maxLen = len(body)
			self.tracing = 0
		if(type(body) == type(self)):
			self.textBody = body.textBody 
			self.textCount = body.textCount
			self.maxLen = body.maxLen

	def __str__(self):
		return self.textBody[self.textCount:]

	def AtTextView(self, offset = 0):
		
		index = self.textCount + offset 
		if ( index < self.maxLen):
			result = self.textBody[index]
		else:
			result = ''
			raise TextViewError, "End Of Text View"
		return result
	
	def Next(self):
		self.textCount = self.textCount + 1
	def MoreText(self):
		return self.textCount < self.maxLen 
	
	def FeedWhitespace(self):
		while (self.textCount < self.maxLen and
			self.textBody[self.textCount] in string.whitespace):
			self.textCount = self.textCount + 1
			
	def Reset(self):
		self.textCount = 0
	def SetStartPoint(self):
		self.startPoint = self.textCount
	def LastText(self):
		return self.textBody[self.startPoint, self.textCount]

	def GoUntil(self,string):
		l = len(string)
		while (self.textBody[self.textCount,self.textCount + l] != string
				and self.textCount + 1 <= self.maxLen ):
			self.textCount = self.textCount + 1

class ProdList:
	#an 'instance-less' class - each is essentiallly the same object
	#a single global matrix with all the 
	#formatting commands for the document
	
	fileProdKey = 'STANDARD_SITE_FILE'
	fileBaseSerialNum = MySerialNumber.DecQuantity('1')

	theProdList = {}
	theCurrentProdFile = ""
	allProdFiles = []
	dirtyToAddProdFiles = []
	dirtyToRebuildFiles = []
	prodsToAppend = []
	dynamicProductions = {}
	theGlobSerialNumbers = SerialNumList.QuantList()
	
	htmlFileToSerialNum = None
	fileToSpecIndex = None
	keyNameToFileIndex = None

	def __init__(self):
		if ProdList.htmlFileToSerialNum is None:
			ProdList.htmlFileToSerialNum = GenericCache.GenericCache(
				'htmlFileToSerialNum',MyUtil.MainObjectCache)
		if ProdList.fileToSpecIndex is None:
			ProdList.fileToSpecIndex = GenericCache.GenericCache(
				'fileToSpecIndex',MyUtil.MainObjectCache)
		if ProdList.keyNameToFileIndex is None:
			ProdList.keyNameToFileIndex = GenericCache.GenericCache(
				'keyNameToFileIndex',MyUtil.MainObjectCache)
		self.expandRecursion = 0
		
	def Cleanup(self):
		MyUtil.MainObjectCache.Flush()
		
	def ConditionalFileLoad(self, key, serialNum):
		keySerial = key
		if serialNum is not None:
			keySerial = key + serialNum.__str__()

		if not ProdList.keyNameToFileIndex.has_key(keySerial):
			keySerial = key
			if not ProdList.keyNameToFileIndex.has_key(keySerial):
				return

		containedFile = ProdList.keyNameToFileIndex[keySerial]
		if containedFile not in ProdList.allProdFiles:
			self.LoadProd(containedFile,1)
		
	def ProdFromKey(self, key, caller = None):
		if type(key) == type(""):
			keySerialNum = None
			theKey = key
		else:
			if type(key.stringOrList) != type(""):
				return None
			theKey = key.stringOrList
			keySerialNum = ProdItterate.ItemCopy(key.serialNum)
		
		theKey = string.strip(theKey)
		theKey = string.upper(theKey)

		self.ConditionalFileLoad(theKey, keySerialNum)
		
		if (type(caller) == types.InstanceType and 
			keySerialNum is None):
			keySerialNum = ProdItterate.ItemCopy(caller.serialNum)

		if (not ProdList.theProdList.has_key(theKey)):
			return None
		
		serialList = ProdList.theProdList[theKey]

		#use serial number first, then generic name
		resProd = serialList.At(keySerialNum)
		if resProd is None:
			resProd = serialList.At(None)
		if (resProd is not None 
			and len(resProd.tokenList) == 1
			and keySerialNum is not None):
			resProd = serialList.At(None)
		
		
		if resProd is not None:
			resProd.SetSerialNum(keySerialNum)
			if type(key) == types.InstanceType:
				#This ItemCopy is Crucial to be able to independently
				#modify the Productin that we return!!!
				resProd.tokenList[0] = \
					ProdItterate.ItemCopy(key) 
				if key.parent is not None:
					resProd.tokenList[0].SetAsParent(key.parent) 
			return resProd
		return None
			
	def SublistFromKey(self,key,searchSpec):
		if type(key) == types.InstanceType:
			key = key.stringOrList
			initialNum = ProdItterate.ItemCopy(key.serialNum)
		theKey = string.upper(key)
		theKey = string.strip(theKey)
			
		baseRes = []
		if ProdList.theProdList.has_key(theKey):
			serialList = ProdList.theProdList[theKey]
			#use serial number first, then generic name
			allProds = serialList.ChildListAt(searchSpec)
			if allProds is not None:
				if (searchSpec.sortBy):
					allProds = \
						self.SortListByKey(
							allProds ,searchSpec)
				
				if searchSpec.nestBy:
					self.ClumpList(allProds ,searchSpec)
					
				for x in allProds:
					baseRes.append(x.tokenList[0])
				return baseRes
		else:
			MyUtil.errorLog.append(
				'Got Empty List from key ' + theKey +
				' Doing SublistFromKey'+ ' with serial num'
				+ searchSpec.baseNum.__str__())
		return baseRes 
	
	#Sorts list using sort() and dictionary
	#
	# **
	def SortListByKey(self,ProdListToSort,searchSpec):
		SortDict = {}
		ListToSort = []
		theNulls = []
		MyUtil.Assert(type(searchSpec.sortBy) == type(""))
		for x in ProdListToSort:
			valString = x.KeyValue(searchSpec.sortBy)
			if valString  is None or (valString == ''):
				if (searchSpec.putNulls == 'nowhere'):
					continue
				theNulls.append(x)
			else:
				if valString not in ListToSort:
					ListToSort.append(valString  )

				if SortDict.has_key(valString):
					SortDict[valString].append(x)
				else:
					SortDict[valString] = [x]
		
		#We just assume this sorts according pref
		ListToSort.sort()
		
		NewList = []
		for x in ListToSort:
			NewList = NewList + SortDict[x]
		if (searchSpec.putNulls == 'last'):
			NewList = NewList  + theNulls
		if (searchSpec.putNulls == 'first'):
			NewList  = NewList + ListToSort

		NewList.reverse()
		
		return NewList 
	
	def ClumpList(self,keyList,searchSpec):
		if MyUtil.IsStringNumber(searchSpec.nestBy):
			return self.ClumpListByNum(
				keyList,
				searchSpec.nestBy)
		else:
			return self.ClumpListByField(
				keyList,
				searchSpec.nestBy)
	
		#Algorythm nearly identical to sorting but 
	
	#the result are different
	#For optimizing, don't sort if we're going to clump
	def ClumpListByField(self,keyList,searchSpec):
		ClumpDict = {}
		ListToClump = []
		NullsList = []
		for x in keyList:
			keyString = x.KeyValue(searchSpec.nestBy)
			if keyString =="":
				if (searchSpec.putNulls == 'nowhere'):
					continue
				else:
					NullsList.append[x]			
			ListToClump.append(keyString )
			if not ClumpDict.has_key(keyString):
				ClumpDict[keyString] = []
			SortDict[keyString].append(x)
		
		ListToClump .sort()
		NewList = []
		for x in ListToClump:
			justTokens = []
			if self.returnSortField:
				subList = SortDict[x][1:]
			else:
				subList = SortDict[x]
			for y in subList: 
				justTokens.append(y.tokenList[0])
			(SortDict[x][0]).tokenList[0].SetStringValues(
				searchSpec.searchKey, justTokens) 
			if self.returnSortField:
				NewList(MyToken.Token(x,'nt'))
			else:
				NewList.Append(SortDict[x][0])
		return NewList 
	
	def ClumpListByNum(self,keyList,searchSpec):
		l = len(keyList)
		i = 0
		clump = searchSpec.clumpSize
		resList = []
		while(clump*i < l):
			justTokens = []
			if self.returnSortField and i > 0:
				justTokens.append(clump*(i-1))
			for y in keyList[clump*(i-1)+1:clump*(i)]: 
				justTokens.append(y.tokenList[0])
			keyList[clump*(i)].tokenList[0].SetStringValues(
				searchSpec.searchKey, justTokens) 
			if self.returnSortField:
				resList.append(
					MyToken.Token('%d' % i, 'nt'))
			else:
				resList.append(
					keyList[clump*(i)])
			i = i + 1
		#Now get the stragglers
		justTokens = []
		if self.returnSortField and i > 0:
			justTokens.append(clump*(i-1))
		for y in keyList[clump*(i-1)+1:l]: 
			justTokens.append(y.tokenList[0])
		keyList[l].tokenList[0].SetStringValues(
			searchSpec.searchKey, justTokens) 
		if self.returnSortField:
			resList.append(
				MyToken.Token('%d' % l, 'nt'))
		else:
			resList.append(
				keyList[l])
		return resList
		
	def CombineCommandStrings(self):
		keyList = ProdList.dynamicProductions.keys()
		maxSize = len(keyList)
		
		if maxSize == 0:
			return
		newList = {}
		newList[keyList[0]] = ProdList.dynamicProductions[keyList[0]]
		i = 1
		while( i < maxSize ):
			actor = keyList[i]
			consumed = 0
			for x in newList.keys():
				if x == actor:
					consumed = 1
					ProdList.dynamicProductions[x
						].CombineProduction(
							ProdList.dynamicProductions[
								Actor])
			
			#if it hasn't acted on anything			
			if not consumed:
				newList[Actor] = ProdList.dynamicProductions[x]
			i = i + 1
				
		ProdList.dynamicProductions = newList
	
	#get the highest/last serial number 
	#BELOW the supplied
	#to use in inserting 
	#new production values,
	#We need to somehow make this universal 
	#or somehow relate our input to the item in this list!!
	def NextSerialNumBelow(self,initialNum):
		result = \
				ProdList.theGlobSerialNumbers.NextNumberBelow(
				 	ProdItterate.ItemCopy(initialNum))
		
		return ProdItterate.ItemCopy(result)
	
	def NextSerialNumAtBelow(self,theKey, keySerialNum = None):
		if keySerialNum is None:
			return None
		theKey = string.upper(theKey)
		theKey = string.strip(theKey)
		if ProdList.theProdList.has_key(theKey):
			serialList = ProdList.theProdList[theKey]
			return serialList.NumberBelowAt(keySerialNum)
		return None
		
	def NextSerialNumAtSib(self,theKey, keySerialNum = None):
		if keySerialNum is None:
			return None
		theKey = string.upper(theKey)
		theKey = string.strip(theKey)
		if ProdList.theProdList.has_key(theKey):
			serialList = ProdList.theProdList[theKey]
			return serialList.NumberSiblingAt(keySerialNum)
		return None
		
	#create a not-yet-used serial number to insert after the given
	#number that is used
	def NextSerialNumForInsert(self,serialNum):
		return ProdList.theGlobSerialNumbers.NumberAfterInsert(
					serialNum)
	
	def TokenFromSerialNum(self, baseNum,neededTypeString = None):
		BaseProd = ProdList.theGlobSerialNumbers.At(baseNum) 
		if BaseProd is not None:
			res = ProdItterate.ItemCopy(BaseProd.tokenList[0])
			res.SerialNum = ProdItterate.ItemCopy(baseNum)
			return res
		return None
	
	#Token of given key starting from a 
	def TokenAboveFromSerialNum(self, baseNum,neededTypeString = None):
		startNum = baseNum.Parent()
		if startNum == None:
			startNum = MySerialNumber.DecQuantity('0')
		BaseProd = ProdList.theGlobSerialNumbers.At(startNum) 
		
		if neededTypeString is None or neededTypeString == '':
			res = BaseProd.tokenList[0]
			res.SerialNum = startNum 
		
		while BaseProd.tokenList[0].ToBaseString() != needTypeString:
			startNum = startNum.Parent()
			if startNum == None:
				startNum = MySerialNumber.DecQuantity('0')
			BaseProd = ProdList.theGlobSerialNumbers.At(startNum) 
		
		res = BaseProd.TokenList[0]
		res.SerialNum = startNum
		
		return res

	def FileSerialNumber(self,FileName):
		if ProdList.htmlFileToSerialNum.has_key(FileName):
			return MySerialNumber.DecQuantity().ParseSerialNum(
				ProdList.htmlFileToSerialNum[FileName])
		else:
			newNum = self.NextSerialNumBelow(
					ProdList.fileBaseSerialNum)
			ProdList.htmlFileToSerialNum[FileName] = newNum.__str__()
			return newNum


	def LoadGeneratedProds(self):
		files = glob.glob(MyUtil.AdjustPath('*.' + MyUtil.BasicProdExten))
		for x in files:
			self.LoadProd(x,forceLoad = 0)

	def LoadProd(self, view =
				 MyUtil.baseFileName,
				 forceLoad = 1,
				 fullPath = None):

		if type(view) == type(''):
			#ignore openning errors
			try:
				if fullPath is None:
					theFilePath = os.path.join(
								MyUtil.baseFilePath,
								view )
				else:
					theFilePath = fullPath

				newSpec = os.stat(theFilePath)
				ext = os.path.splitext(theFilePath)[1]
				if ext != '.bbs':
					verboseFile = 1
				else:
					verboseFile = 0
				
				if not forceLoad:
					if (ProdList.fileToSpecIndex.has_key(theFilePath) and
						theFilePath != MyUtil.baseFileName ):
						oldtime  = ProdList.fileToSpecIndex[theFilePath]
						if (newSpec[stat.ST_MTIME]
							 <= oldtime ):
							return

				ProdList.fileToSpecIndex[theFilePath] = newSpec[stat.ST_MTIME]

				if not verboseFile:
					baseFile = open(MyUtil.AdjustPath(theFilePath))
			except IOError:
				MyUtil.Assert(0)
				MyUtil.errorLog.append(
					"Error loading file " +  view )
				return
			if verboseFile:
				baseFileName = os.path.splitext(
					os.path.basename(theFilePath))[0]
				HtmlBlock.ProdFromFile(theFilePath,
					baseFileName,
					replaceOrig = 0)
				return
			baseView = TextView(baseFile.read(-1))
			ProdList.theCurrentProdFile = view
		elif type(view) == type(TextView()):
			baseView = view
			ProdList.theCurrentProdFile = MyUtil.DynaTextName

		if ProdList.theCurrentProdFile not in ProdList.allProdFiles:
			ProdList.allProdFiles.append(
				ProdList.theCurrentProdFile)
		
		self.parseProdListText(baseView)


	
	def ModifyValues(self):
		for x in ProdList.prodsToAppend:
			if self.AppendProd(x):
				ProdList.prodsToAppend.remove(x)
		#self.CombineCommandStrings()
		
	def WriteFiles(self):
		appendBufs= {}
		insertBufs = {}
		for x in ProdList.dirtyToAddProdFiles:
			appendBufs[x] = open(MyUtil.AdjustPath(x),'a+')
		for x in ProdList.dirtyToRebuildFiles :
			insertBufs [x] = open(MyUtil.AdjustPath(x),'w')
		for x in ProdList.theProdList.keys():
			serialList = ProdList.theProdList[x]
			listItter = serialList.NextItteration([None,None,None])
			#add current productions and all old productions
			while(listItter is not None):
				someProd = listItter[1]
				oldProds = listItter[2]
				#Null is an empty parent node
				
				if (someProd.containerFile 
					in ProdList.dirtyToAddProdFiles):
					if someProd.isNew:
						res = appendBufs[someProd.containerFile].write( 
							' \n ' + someProd.__str__())
				
				elif (someProd.containerFile 
					in ProdList.dirtyToRebuildFiles):
					res = insertBufs[someProd.containerFile].write( '\n ' + someProd.__str__())
				
					for y in oldProds:
						if (y.containerFile 
							in ProdList.dirtyToRebuildFiles):
							res = insertBufs[
								y.containerFile].write( '\n ' 
									+ y.__str__())
				listItter = serialList.NextItteration(
					listItter)
	
	def DynamicProductions(self):
		accum = ""
		for x in ProdList.dynamicProductions.keys():
			accum = accum + \
				ProdList.dynamicProductions[x].__str__() + ' '
		return accum
	
	def AppendProd(self, newProduction):
		theSerialNum = newProduction.ItsSerialNum()
		theKey = (newProduction.ItsKey())
		theKey = theKey[1:]
		if theSerialNum is not None:
			initialProd = self.ProdFromKey(
				MyToken.Token(theKey,'nt',theSerialNum), 
					newProduction.tokenList[0])

			#We don't to create a generic value
			if initialProd is None or (
				initialProd.ItsSerialNum() is None):
				return
		else:
			initialProd = self.ProdFromKey(theKey,
						newProduction.tokenList[0])
			
		if initialProd is not None:
			initialProd.CombineProduction(newProduction)

	#This is base on EITHER string OR serialNumber
	def ExistsProd(self,newProd):
		theNum = newProd.ItsSerialNum()
		theKey = newProd.ItsKey()
		if theNum is not None:
			theProd = ProdList.theGlobSerialNumbers.At(theNum)
			if theProd is not None:
				return 1
			else:
				return 0
		else:
			#ONLY if serialNumber IS None
			if ProdList.theProdList.has_key(theKey):
				theList = ProdList.theProdList[theKey]
				if theList.At(theNum) is not None:
					return 1

			return 0
				
	#Modify a production Using a copy of another production
	def AddToExistingProd(self,newProduction):
		existingProd = \
			self.ProdFromKey(newProduction.ItsKey())
		MyUtil.Assert(existingProd)
		existingProd.tokenList = existingProd.tokenList + \
			MyToken.RecursiveCopy(newProduction.tokenList[1:])

	#This will remove all of the prod's children as well
	def RemoveProd(self, theKey):
		MyUtil.Assert(
			type(theKey) == types.InstanceType)
		theSerialNum = theKey.serialNum
		theKey = theKey.ToBaseString()
		theKey = string.upper(theKey)
		theKey = string.strip(theKey)
		if (not ProdList.theProdList.has_key(theKey)):
			realKeyToken = self.TokenFromSerialNum(theSerialNum )
			if realKeyToken is None:
				MyUtil.Assert(0)
				return 0
			realKey = realKeyToken.ToBaseString()
			realKey = string.upper(realKey)
			if (not ProdList.theProdList.has_key(realKey)):
				MyUtil.Assert(0)
				return 0
			theKey = realKey

		ToRemoveList = ProdList.theGlobSerialNumbers.AllChildrenAt(
			theSerialNum)
		for x in ToRemoveList:
			self.RemoveSingleEntry(x[0],(x[1].ItsKey()))
	
	
	def RemoveSingleEntry(self, theSerialNum, theKey):
		if (not ProdList.theProdList.has_key(theKey)):
			MyUtil.Assert(0)
			return 0
		toRemove = self.ProdFromKey(MyToken.Token(theKey,'nt',theSerialNum) )
		serialList = ProdList.theProdList[theKey]	
		success = serialList.RemoveAt(theSerialNum)
		if (success and toRemove.containerFile
			not in ProdList.dirtyToRebuildFiles):
			ProdList.dirtyToRebuildFiles.append(
				toRemove.containerFile)

		ProdList.theGlobSerialNumbers.RemoveAt(theSerialNum)


	
	def AddProd(self,newProduction,isDirty = 0,fileName=''):
		theSerialNum = ProdItterate.ItemCopy(
			newProduction.ItsSerialNum())
		theKey = newProduction.ItsKey()
		keyString = string.upper(theKey)
		keyString = string.strip(keyString)
		
		if fileName != '':
			newProduction.containerFile = fileName
		
		if (newProduction.containerFile == MyUtil.baseFileName):
			newProduction.containerFile = MyUtil.postFileName
	
		if (type(theKey) != type("")):
			return 0
		if(keyString == ""):
			return 0

	
		if theKey[0] == '*':
			if not self.AppendProd(newProduction):
				if len(newProduction.tokenList) < 2:
					return
				ProdList.prodsToAppend.append(newProduction)
	
		elif ProdList.theProdList.has_key(keyString):
			serialNumList = ProdList.theProdList[keyString]
			serialNumList.Add(theSerialNum,newProduction)
			
		#Adding a new token
		else:
			serialNumList = SerialNumList.QuantList()
			serialNumList.Add(theSerialNum,
						newProduction)
			ProdList.theProdList[keyString]= serialNumList
		
		if theSerialNum is not None:
			testProd = ProdList.theGlobSerialNumbers.Add(
					theSerialNum,newProduction)
			if testProd is not None:
				MyUtil.errorLog.append(
					"Duplicate Serial Numbers in" 
					+ newProduction.__str__() + " and "
					+testProd.__str__()
					)
			
		if theSerialNum is not None:
			keySerial = keyString + theSerialNum.__str__()
		else:
			keySerial = keyString
		ProdList.keyNameToFileIndex[keySerial] = newProduction.containerFile

		if newProduction.containerFile == MyUtil.DynaTextName:
			if ProdList.dynamicProductions.has_key(keySerial):
				ProdList.dynamicProductions[keySerial
					].CombineProduction(newProduction)
			else:
				ProdList.dynamicProductions[keySerial] = newProduction
			
		if newProduction.containerFile not in ProdList.allProdFiles:
			ProdList.allProdFiles.append(
				newProduction.containerFile)
		
		if isDirty:
			if newProduction.containerFile not in ProdList.dirtyToAddProdFiles:
				ProdList.dirtyToAddProdFiles.append(newProduction.containerFile)
			newProduction.isNew = 1
		return 1
	
	def ShowKeysDebug(self):
		for x in self.theProdList.keys():
			MyUtil.DebugOut(x)
			MyUtil.DebugOut(theProdList.at(x.at(None)))
	
	def ParseAProd(self,counterView):
		ParsedList = []
		#skip everything outside nested brackets
		bookMark = counterView.textCount 
		try:
			while((counterView.textBody[counterView.textCount]!='[' or 
				counterView.textBody[counterView.textCount]=='~')
				and (counterView.textCount < counterView.maxLen)) :
				counterView.textCount = counterView.textCount + 1
			if(not (counterView.textCount < counterView.maxLen)):
				return Production.Production()
			counterView.textCount = counterView.textCount + 1
			if(not (counterView.textCount < counterView.maxLen)):
				return Production.Production()
		
			ParsedList.append(self.ParseInitialToken(counterView))
			
			counterView.FeedWhitespace()
			if(counterView.textBody[counterView.textCount] != ']'):
				counterView.textCount = counterView.textCount + 1
				while 1:
					ParsedList.append(
						self.ParseTokenOrList(
									counterView))
					counterView.FeedWhitespace()
					if(counterView.textBody[counterView.textCount]==']' 
						or counterView.textBody[counterView.textCount] =='|'):
						break
					else:
						counterView.textCount = counterView.textCount + 1
			#else: do nothing
		except (IndexError, MyUtil.BBS_SYNTAX_ERROR):
			theRest = counterView.textBody[bookMark:]
			theRest = string.strip(theRest)
			if  theRest != '':
				MyUtil.errorLog.append(
					"Unexpect End Of Expression at " 
					+ counterView.textBody[bookMark:] 
					)
			return Production.Production()	

		fileName = ProdList.theCurrentProdFile
		counterView.textCount = counterView.textCount + 1
			#fill in list
		result = Production.Production(ParsedList,
					ProdList.theCurrentProdFile)
		return result
	
	#initial token has a string and a serial number only
	def ParseInitialToken(self,counterView):
		startIndex = counterView.textCount 
		
		#Optimized section
		c = counterView.textBody[counterView.textCount]
		if counterView.textCount > 0:
			b = counterView.textBody[counterView.textCount-1]
		else: 
			b = ''
		while (counterView.textCount < counterView.maxLen) and (
			( (c != ']') and (c != Production.PROD_DELIM) 
			and (c not in string.digits) and (c != '-') )
			or b == "~"
			):
			counterView.textCount = counterView.textCount + 1
			c = counterView.textBody[counterView.textCount]
			b = counterView.textBody[counterView.textCount-1]
			
		endIndex = counterView.textCount 
		tokenText = counterView.textBody[startIndex:endIndex]
		
		c = counterView.textBody[counterView.textCount]
		if (c in string.digits or (c == '-')):
			serialNum = MySerialNumber.DecQuantity().ParseSerialNum(counterView)
			#anything after the first number
		else:
			serialNum = None
		
		tokenText = string.strip(tokenText)
		return MyToken.Token(tokenText,'nt',serialNum)

	#turns a string represent a nested arrays into a python object
	# Use ~ as the escapse character
	def ParseTokenOrList(self,counterView):
		counterView.FeedWhitespace()
		startIndex = counterView.textCount 
		if counterView.textBody[counterView.textCount] == '[':
			result = []	
			counterView.textCount = counterView.textCount + 1
			while 1:
				result.append(
					self.ParseTokenOrList(counterView))
				if(counterView.textBody[counterView.textCount] 
					== ']'):
					while(counterView.textBody[
							counterView.textCount] 
						in string.whitespace):
						counterView.textCount = \
							counterView.textCount + 1	
					nextChar = counterView.textBody[
							counterView.textCount] 
					MyUtil.SyntaxRequire((nextChar==',')
							or (nextChar == ']'))
					break
				counterView.textCount = counterView.textCount + 1
			counterView.textCount = counterView.textCount + 1
			
			return MyToken.Token(result)
		else:
			if counterView.textBody[counterView.textCount] == "'":
				theType = 'terminal'
				#skipping 1st quote here
				counterView.textCount = counterView.textCount + 1 
				startIndex = counterView.textCount 
				
				
				#Optimized section
				c = counterView.textBody[counterView.textCount]
				if counterView.textCount > 0:
					b = counterView.textBody[counterView.textCount-1]
				else: 
					b = ''
				while ((counterView.textCount < counterView.maxLen)
					and ((c != "'") or b == "~")):
					counterView.textCount = counterView.textCount + 1
					c = counterView.textBody[counterView.textCount]
					b = counterView.textBody[counterView.textCount-1]
				endIndex = counterView.textCount 
				#skipping last quote here
				counterView.textCount = counterView.textCount + 1
				tokenText = counterView.textBody[
							startIndex:endIndex]
			else:
				theType = 'nt'
				endIndex = counterView.textCount 
				
				
				#Optimized section
				c = counterView.textBody[counterView.textCount]
				if counterView.textCount > 0:
					b = counterView.textBody[counterView.textCount-1]
				else: 
					b = ''
				while (((counterView.textCount < counterView.maxLen)
					and c != ']' and c != Production.PROD_DELIM ) or 
					b == "~"):
					counterView.textCount = counterView.textCount + 1
					c = counterView.textBody[counterView.textCount]
					b = counterView.textBody[counterView.textCount-1]
				
				endIndex = counterView.textCount
				tokenText = counterView.textBody[
							startIndex:endIndex]
				tokenText = string.strip(tokenText)
			return MyToken.Token(tokenText,theType)
	
	#parse List of form [ Key:string]  or [ Key: [string1,string2]] 
	def parseProdListText(self,ProdText):
		counterView = TextView(ProdText)
		while (counterView.textCount < counterView.maxLen):
			newProd = self.ParseAProd(counterView)
			self.AddProd(newProd) 

	#Only if the files are later
	#And the base file
	def LoadProdFromFile(self, filePathName):


		f = Open(MyUtil.AdjustPath(filePathName))
		if f is None:
			return None
		body = f.read(-1)
		rawStrings = re.split(body,'< *BBStag = (.*)?>.*?</BBStag>')
		#Our non-terminals should be odd, 
		#Our terminals should be even
		#Empty strings are filled in.
		tokens = []
		for i in range(rawStrings):
			if i % 2 == 0:
				tokens.append(MyToken.Token(rawStrings[i],'nt'))
			else:
				tokens.append(MyToken.Token(rawStrings[i]))
		return tokens
	
	def __str__(self,key = None):
		res = ""
		if key is None:
			for i in ProdList.theProdList.keys():
				baseList = ProdList.theProdList[i]
				head = baseList.At(None)
				if head is not None:
					res = res + head.__str__() + '\n'
				listItter = baseList.NextItteration([None,None])
				while(listItter is not None):
					res = res + listItter[1].__str__()
					res = res + '\n'
					listItter = baseList.NextItteration(
						listItter)
			return res
		else:
			return ProdFromKey(key).__str__()
	
	def ExpandToView(self,listORtoken = MyToken.Token('S','nt')):
		self.expandRecursion = self.expandRecursion + 1
		MyUtil.Assert(self.expandRecursion  < 100)

		if( type(listORtoken) == types.InstanceType ):
			if type(listORtoken.stringOrList) != type(""):
				self.expandRecursion = self.expandRecursion - 1
				return ''
			
			if(listORtoken.tokenType  == "terminal"):
				result = listORtoken.ToFormattedString()
				if (MyUtil.outFile.isDebugTracing
					and listORtoken.isTracer == 0):
					result = '[t:] ' + result
			elif(listORtoken.tokenType  == "appender"):
				result = listORtoken
			else:
				theProd = self.ProdFromKey(listORtoken)
				if theProd is None:
					MyUtil.errorLog.append(
						'Got Null Prod from ' + listORtoken.__str__() )
					result = ""
					if MyUtil.outFile.isDebugTracing:
						result = '[('+ listORtoken.__str__() +'-nf)]' 
				else:
					MyUtil.DebugOut('\n')
					MyUtil.DebugOut('Starting with: ')
					MyUtil.DebugOut(listORtoken)
					opperatedTokenOrList = theProd.DoProd()
					MyUtil.DebugOut('\n')
					MyUtil.DebugOut('The intermediate step is: ')
					MyUtil.DebugOut(opperatedTokenOrList)
					result = self.ExpandToView(opperatedTokenOrList)
					MyUtil.DebugOut('\n')
					MyUtil.DebugOut('Final step is: ')
					MyUtil.DebugOut(opperatedTokenOrList)
			
			if (result == '' and listORtoken.__str__()!='' 
				and listORtoken.__str__()!="''"):
				MyUtil.errorLog.append(
					'Null result for ' 
					+ listORtoken.__str__() )
			self.expandRecursion = self.expandRecursion - 1
			return result
			
		elif type(listORtoken) == type([]):
			parsedList = []
			for x in listORtoken:
				expanded = self.ExpandToView(x)
				parsedList = parsedList + [expanded]
			if len(parsedList) == 0:
				self.expandRecursion = self.expandRecursion - 1
				return ''
			combinedString = MyUtil.RecurSumStringTokList(parsedList)
			self.expandRecursion = self.expandRecursion - 1
			return combinedString

			
		#elif type(listORtoken) == type(""):
		#	self.expandRecursion = self.expandRecursion - 1
		#	return listORtoken
		MyUtil.Assert(0)	

global minProdList
minProdList = ProdList()

if __name__=='__main__':
	test()
