
#Crucial Questions Better BBS 
#Copyright 2000 Hans Joseph Solbrig
#
#See License Agreement in distribution


import os
import dircache
import Mycgi #cgi tweeked for non-unix systems
import regex
import regsub
import string
from string import *
import copy
import profile
import time
import types
import pdb

import MyControl
import MyToken
import Production
import Prod
import MySerialNumber
import SerialNumList
import MyUtil
import MyAdmin

def Split(theString, commandDelim, showDelim):
	return MyUtil.Split(theString, commandDelim,showDelim)

def Strip(theObject):
	if type(theObject) == type(""):

		while(1):
			theObject = \
				string.strip(theObject )
			if(theObject and theObject[0] == '('
				and theObject[-1] == ')'):
				theObject  = \
					theObject[1:-1]
			else:
				return theObject
			
	elif type(theObject) == type([]):
		for i in range(len(theObject)):
			theObject[i] = Strip(theObject[i])
		return theObject
	Util.Assert(0)

def ItemCopy(item ):
	if type(item ) == types.InstanceType:
		return item.ACopyOf()
	return item

def AsKey(forKey):
	if type(key) == type(""):
		theKey = forKey
	else:	
		theKey = forKey.ToBaseString()
	theKey = string.strip(theKey)
	theKey = string.upper(theKey)
	return theKey

def AsSerialNum(self, key):		
	if type(key) == type(""):
		return None
	else:	
		return key.serialNum

class ProdItterator:
	def __init__(self,
			itsToken = None ,
			parentToken = None,
			extensionCommand = '',
			proxyToken = None):
		self.prodTokens = itsToken
		self.parentToken = parentToken
		self.tokenCount = 0
		self.extensionItter = None
		self.extensionToken = None
		self.doAction = 1
		self.extensionCommand = extensionCommand 
		self.extensionString = ""
		
		self.proxy = proxyToken
		if self.proxy is not None:
			self.itterSerialNum = ItemCopy(self.proxy.serialNum)
			MyUtil.Assert(type(self.proxy) == types.InstanceType)
		
		self.containerFile = None

	def DoProd(self):
		resultList = []
		result = self.NextProd()
		while result is not None:
			if (type(result) == types.InstanceType and
				len(result.stringOrList)!= 0):
				resultList.append(result)
			result = self.NextProd()

		if MyUtil.outFile.isDebugTracing:
			resultList = [self.TracerString()] + resultList

		return resultList

	def TracerString(self):
		outStr = self.parentToken.ToBaseString()
		if (self.parentToken.serialNum is not None
			 and (self.parentToken.parent.serialNum is not None)
			 and (self.parentToken.parent.serialNum !=
				  self.parentToken.serialNum)):
			outStr = outStr + self.parentToken.serialNum.__str__()
		traceToken = MyToken.Token( outStr + ': ')
		traceToken.isTracer = 1
		return traceToken

	#Takes defines from a 
	def CarryingOverDefines(self,resultToken):
		if (self.tokenCount - 1 >=
			len(self.prodTokens.stringOrList)):
			return
		if self.tokenCount == 0:
			return

		derivedProd = Prod.minProdList.ProdFromKey(
			self.prodTokens.stringOrList[self.tokenCount -1 ])
		if derivedProd is not None:
			subList = derivedProd.tokenList
			if len(subList) < 1:
				return
			subList = subList[1:]

			for x in subList:
				if x.IsTransform():
					self.DoDefinition(resultToken,x)
		return

	def NextProd(self,doAction = 1):
		self.doAction = doAction 
		if self.tokenCount >= len(self.prodTokens):
			if self.extensionToken is None:
				return None
			self.tokenCount = 0
			self.extensionToken = \
				self.extensionItter.NextProd()
			if(self.extensionToken is None):
				return None
				
			#Since we're working w/ a copy, must establish 
			#full parent relations
			grandParent = self.parentToken.parent
			self.parentToken = ItemCopy(self.parentToken)
			self.parentToken.SetAsParent(grandParent)
			if self.proxy is not None:
				self.parentToken.SetStringValues(
					'ProxyToken',self.extensionToken)

		newToken = self.prodTokens.stringOrList[
				self.tokenCount].ACopyOf()

		if newToken.serialNum is None or \
			newToken.serialNum.IsNull():
			newToken.serialNum = ItemCopy(self.itterSerialNum)
		result = self.EvaluateToken(newToken)
		
		if result is not None:
			self.PassCharacteristics(result)
		self.tokenCount = self.tokenCount + 1

		if self.proxy is not None:
			res = ItemCopy(self.proxy)
			res.serialNum = ItemCopy(result.serialNum)
			res.SetAsParent(result)
			res.SetStringValues('BaseToken',result)
			result = res
			self.CarryingOverDefines(result)

		if self.extensionToken is not None:
			self.extensionItter.CarryingOverDefines(result)

		return result

	def PassCharacteristics(self,listOrToken):
		listOrToken.SetAsParent(self.parentToken)

	def EvalAsNumber(self,theString):
		if MyUtil.IsStringNumber(theString):
			return string.atoi(theString)
		value = self.parentToken.GetSetNumber(theString)
		if (type(value) == type(0) and value > 0):
			return value
		theString = self.Eval(theString)
		if MyUtil.IsStringNumber(theString):
			return string.atoi(theString)
		resString =	self.parentToken.GetSetString(
					theString)
		if MyUtil.IsStringNumber(resString):
			return string.atoi(resString)

		return -1

	
	def Eval(self,theString):
		#The following code MIGHT or might NOT speed up the program
		#
		#if type(theString) == type(""):
		#	if len(theString) == 0:
		#		return theString
		#	theString = string.strip(theString)
		#	if (theString[0] not in MyUtil.token_commands and
		#			(theString[0] not in ['(',"'"])):
		#		return theString
		return self.EvaluateToken(theString).ToBaseString()
	
	def EvaluateToken(self, actionToken, doingSubstitution = 0):
		try:
			if type(actionToken) != type(""):
				actionString  = actionToken.__str__()
				if actionToken.IsTransform(): #was IsList
					return self.SetDefinition(actionToken)
				if actionToken.tokenType == 'terminal':
					return actionToken
				actionString  = actionToken.ToBaseString()
			else:
				actionString  = actionToken
			actionString = Strip(actionString)
			if (actionString  == "" ):
				return MyToken.Token("")
			if (actionString [0] == "'" and 
				(actionString  [-1] == "'")):
				actionString   = actionString [1:-1]
				return MyToken.Token(actionString ,
							'terminal',
							self.itterSerialNum)
			if actionString [0] not in MyUtil.token_commands:
				if type(actionToken) == type(""):
					return MyToken.Token(actionToken,'nt')
				else:
					return actionToken
			
			commandDelim = actionString [0]
			defFields = Split(actionString ,commandDelim,0)
			if len(defFields) == 0:
				defFields.append(' ')
	
			defFields = Strip(defFields)
			evaluatedToken = None
			if commandDelim == '$':
				evaluatedToken = self.SubValues(defFields)
			elif commandDelim == '*':
				evaluatedToken = self.DoFunction(defFields,
								doingSubstitution)
			elif commandDelim == '&':
				evaluatedToken = self.LogicEval(defFields)
			elif commandDelim == '+':
				evaluatedToken = self.Concatnate(defFields)
			elif commandDelim == '!':
				evaluatedToken = self.ExtendByToken(defFields)
			elif commandDelim == '%':
				evaluatedToken = self.IndexedSubtokens(defFields)
			elif commandDelim == '#':
				evaluatedToken = self.IndexSubstitution(defFields)
			elif commandDelim == '@':
					evaluatedToken = self.PseudoProd(defFields)
			
			if evaluatedToken is None:
				MyUtil.errorLog.append(
						'error or incorrect syntax with' 
						+ actionString )
			
		except MyUtil.BBS_SYNTAX_ERROR:
			#Just get a small piece of the stack for our syntax 
			#errors
			MyUtil.errorLog.append(
				'syntax error from command: ' 
				+ actionString  ) 
			return MyToken.Token()
		
		if (evaluatedToken.serialNum is None and 
			self.itterSerialNum is not None):
			evaluatedToken.serialNum = ItemCopy(self.itterSerialNum)
			
		return evaluatedToken

			
	def GetExprTruthValue(self,booleanStr):
		while(booleanStr[0] == '('
			and booleanStr[-1] == ')'):
			booleanStr = \
				booleanStr[1:-1]
			booleanStr = \
				string.strip(booleanStr)
		booleanStr = \
			string.strip(booleanStr)
		
		
		if(booleanStr[0] == '^'):
			neg = 1
			booleanStr= booleanStr[1:]
		else:	neg = 0 
		
		comparisonStrings = Split(booleanStr,'<=>',1)
		if len(comparisonStrings) > 2:
			value1 = self.EvalAsNumber(comparisonStrings[0])
			value2 = self.EvalAsNumber(comparisonStrings[2])

			#now check for string comparison
			if ((value1 == -1) and (value2 == -1) 
				and comparisonStrings[1] == '='):
				a = self.Eval(comparisonStrings[0])
				b = self.Eval(comparisonStrings[2])
				a = string.upper(a)
				b = string.upper(b)
				isTrue = ((a == b) and not neg) or \
					 ((a != b) and neg) 
					 
				return isTrue
					
			if comparisonStrings[1] == '<':
				hasValue = (value1 < value2)
			elif comparisonStrings[1] == '>':
				hasValue = (value1 > value2)
			elif comparisonStrings[1] == '>=':
				hasValue = (value1 >= value2)
			elif comparisonStrings[1] == '<=':
				hasValue = (value1 <= value2)
			elif comparisonStrings[1] == '=':
				hasValue = (value1 == value2)
			else:
				MyUtil.SyntaxRequire(0,
					'error or incorrect syntax in truth expr')
			isTrue = (hasValue and (not neg)) or \
					(  (not hasValue)   and neg)
				
		else:
			gotResult = 0
			if booleanStr[0] in MyUtil.token_commands:
				booleanToken = self.EvaluateToken(booleanStr)
				MyUtil.SyntaxRequire(not booleanToken.IsTransform())
				
				booleanStr = booleanToken.ToBaseString()
				if booleanStr is not None and (len(booleanStr)>0):
					gotResult = 1
			
			hasValue = self.EvalAsNumber(booleanStr)
			if hasValue == - 1:
				resString =	self.parentToken.GetSetString(
							booleanStr)
				hasValue = ((len(resString)>0) or gotResult)
			isTrue = (hasValue>0)
			if neg: isTrue = not isTrue
		return isTrue

	def SubValues(self, defFields):
		parLevel = 0
		parTok = self.parentToken
		while((defFields[0])[-(parLevel+1) ] == '+'):
			parLevel = parLevel + 1
			if parTok.parent is not None:
				parTok = parTok.parent
		if(parLevel > 0):
			commandStr = (defFields[0])[0:-(parLevel)]
		else:
			commandStr = defFields[0]
		
		returnType = 'nt'
		argIndex = None
		if commandStr[0] == "'":
			commandStr = commandStr[1:]
			returnType = 'terminal'
			
		if (len(defFields) > 1):
			if(MyUtil.IsStringNumber(defFields[1])):
				argIndex = string.atoi(defFields[1])
			elif string.lower(defFields[1]) == 'arg':
				resultString = parentToken.arg[-1] 
				parentToken.SetStringValues((defFields[0]),
					resString,self.itterSerialNum)
				return MyToken.Token(resultString,returnType,
						self.itterSerialNum)
			elif(len(defFields) > 2):
				argIndex = defFields[2]
		
		if argIndex is None:
			argIndex = ItemCopy(self.itterSerialNum)
			
		keyString = (self.Eval(commandStr))
		theCgiValue = MyControl.pageLoader().CgiValue(keyString)
		
		if(theCgiValue!=''):
			theCgiValue = MyUtil.AddControlChars(theCgiValue)
			resultString = theCgiValue
			returnType = 'terminal'
		elif MyToken.Token.globalValues.has_key(keyString):
			resultString = MyToken.Token.globalValues[keyString]
			if type(res) == type(0):
				resultString = ('%d' % resultString )
		else:
			resultString = parTok.GetSetString(keyString,argIndex)
		
		if type(argIndex) == type([]) and ( len(argIndex)>1 ):
			resultString = self.Eval(commandStr)
		
		return MyToken.Token(resultString,returnType,
						self.itterSerialNum)
		
	def DoFunction(self, defFields, doingSubstitution = 0):
		resultString = ''
		returnType = 'nt'
		MyUtil.SyntaxRequire(len(defFields[0]) > 0)

		if (defFields[0])[0] == "'":
			commandStr = (defFields[0])[1:]
			returnType = 'terminal'
		else:
			commandStr = (defFields[0])
		
		parTok = self.parentToken
		while(commandStr[-1] == '+'):
			parLevel = parLevel + 1
			commandStr = commandStr[:-1]
			if parTok.parent is not None:
				parTok = parTok.parent
		commandStr = string.strip(commandStr)
		command = string.lower(commandStr)
		
		if command == 'embed':
			returnType = 'terminal'
			resultString = self.EmbedToken(defFields[1:])

		elif command == 'add':
			value = self.EvalAsNumber(defFields[1]) + \
					self.EvalAsNumber(defFields[2])
			return MyToken.Token(('%d' % value), returnType) 

		elif command == 'Recur':
			value = self.GetRecursionLevel(defFields[1:])
			return MyToken.Token(('%d' % value), returnType) 

		elif command == 'splitToken':
			num = 0
			theChar = MyUtil.splitChar
			if len(defFields) > 1:
				IndexNum = self.EvaluateToken(
					defFields[2])
				if MyUtil.IsStringNumber(IndexNum):
					num = string.atoi(IndexNum)
			if len(defFields) > 3:
				theChar = defFields[3][0]
			tokenString = self.EvaluateToken(
					defFields[1])
			splitArray = re.split(char,tokenString)
			if num < len(splitArray):
				res = splitArray[num]
			else:
				res = ''
		
		elif command == 'tagas':
			return MyToken.Token(
				self.Tagas(defFields))	
					
		elif command == 'setdefault':
			if doingSubstitution:
				return MyToken.Token()
			
			if len(defFields) > 2:
				keyNum = self.EvaluateToken(
					defFields[2]).serialNum
			else: keyNum = self.itterSerialNum

			self.MakeOptionsDefault(keyNum, keyProd)

			return MyToken.Token()	
			
		elif command == 'writeproduction':
			if doingSubstitution:
				return MyToken.Token()
			
			if len(defFields) > 2:
				keyNum = self.EvaluateToken(
					defFields[2]).serialNum
			else: keyNum = self.itterSerialNum
			if keyNum is not None:
				keyNum = Prod.minProdList.NextSerialNumBelow(
					ItemCopy(keyNum))

			if defFields[1][0] == '-':
				defFields[1] = defFields[1][1:]
				keyNum = None

			toWrite = MyUtil.SyntaxRequire(
				self.ProdFromToken(
					self.EvaluateToken(defFields[1])),'Production Missing' )
			toWrite.SetSerialNum(ItemCopy(keyNum))
			
			if len(defFields) > 3:
				toWrite.containerFile = self.EvaluateToken(
					defFields[3]).serialNum
			elif toWrite.containerFile == "":
				toWrite.containerFile = self.containerFile
			
			if keyNum is not None:
				parTok.SetSerialNumber(
					toWrite.ItsKey(),keyNum)
			if (toWrite.ItsKey()[0] == '*'
				or not Prod.minProdList.ExistsProd(toWrite)):
				Prod.minProdList.AddProd(
					toWrite.ACopyOf(),1)
			else: Prod.minProdList.AddToExistingProd(
					toWrite.ACopyOf())
			nullTok = MyToken.Token()
			nullTok.serialNum = keyNum
			return nullTok

		elif command == 'dynamicvalues':
			resultString = Prod.minProdList.DynamicProductions()
			return MyToken.Token(resultString,'terminal',
						self.itterSerialNum)
		
		elif command == 'parent':
			if (len(defFields) > 1):
				num = parTok.GetSetSerialNum(defFields[1])
			else:
				num = ItemCopy(self.itterSerialNum)
			if num is not None:
				par = num.Parent()
			else:
				par = None
			if par is None or par.IsNull():
				par = MySerialNumber.DecQuantity('0')

			if len(defFields) > 2:
				resToken = self.EvaluateToken(defFields[2])
			else:
				resToken = MyToken.Token(par.__str__())
			resToken.SerialNum = par
			return resToken
		
		elif command  == 'childserialnum':
			if (len(defFields) > 1):
				resToken = self.EvaluateToken(defFields[2])
				num = parTok.GetSetSerialNum(defFields[1])
			else:
				resToken = self.EvaluateToken(defFields[1])
				num = ItemCopy(self.itterSerialNum)
			
		elif command  == 'siblingserialnum':
			if (len(defFields) > 1):
				resToken = self.EvaluateToken(defFields[2])
				num = parTok.GetSetSerialNum(defFields[1])
			else:
				resToken = self.EvaluateToken(defFields[1])
				num = ItemCopy(self.itterSerialNum)
			return resToken 
		
		elif command == 'login':
			if doingSubstitution:
				return MyToken.Token()
			
			if (len(defFields) == 3):
				user = self.Eval(defFields[1])
				password = self.Eval(defFields[2])
				str = MyAdmin.UserList().CreateSessionKey(
						user,password)
				return MyToken.Token(str)
			#The rest for display of time
		
		elif command == 'time':
			#For internal time representation
			if (len(defFields) == 1):
				return MyToken.Token(
					'%d' % time.time())

			#The rest for display of time
			#Format needs to be a terminal 
			#So it can have python formatting in it
			formatStr = self.Eval(defFields[1])

			if (len(defFields) == 2):	
				tuple = time.localtime(time.time())				
			else:
				oldTime = self.Eval(defFields[2])
				MyUtil.SyntaxRequire(MyUtil.IsStringNumber(oldTime),
					'error in time format ' + oldTime)
				tuple = time.localtime(string.atoi(oldTime))

			return MyToken.Token(
					time.strftime(formatStr,tuple))
		
		elif command == 'remove':
			#Make sure you add an isAdminVerification
			#MyUtil.Assert(0)
			Prod.minProdList.RemoveProd(
				self.EvaluateToken(defFields[1]))
			return MyToken.Token()

		elif command == 'max':
			if len(defFields) > 1:
				toMax = self.Eval(defFields[1])
				resultNum = MyToken.Token(
						).GetGlobalValue(toMax)
				return MyToken.Token('%d' % resultNum)
			else:
				return MyToken.Token()
		
		elif command == 'parenttext':
			if len(defFields) < 2:
				return MyToken.Token()
			baseNum = self.EvaluateToken(
					defFields[1]).SerialNum
			if len(defFields) > 2:
				needType = self.Eval(defFields[2])
			else:
				needType = None
				
			return Prod.minProdList.TokenAboveFromSerialNum(
						baseNum,needType)
		
		elif command == 'manglestring':
			if len(defFields) < 2:
				return MyToken.Token()
			toMangle = self.Eval(defFields[1])
			return MyToken.Token(
				MyUtil.MangleString(toMangle))
		
		elif command == 'loadfile':
			if len(defFields) < 2:
				return MyToken.Token()
			toLoad = defFields[1]
			if toLoad[0] == "'":
				toLoad = toLoad[1:] 
			if toLoad[-1] == "'":
				toLoad = toLoad[:-1] 
			
			tokenList = Prod.minProdList.LoadProdFromFile(
						toLoad)
			return tokenList
		else:
			result = MyToken.Token(commandStr,returnType,
						self.itterSerialNum)
			if len(defFields) > 1:
				for x in defFields[1:]:
					result.args.append(
						self.Eval(x))
			return result

		return MyToken.Token(resultString,returnType,
						self.itterSerialNum)

	#Sets all the dynamic values so they are saved as defaults of
	#the given serialNumber/Node
	def MakeOptionsDefault(self, keyNum, addingTo):
		action = 0
		#this assumes dynamic productions are in order of effect 
		for x in Prod.ProdList.dynamicProductions:
			dProd = itemCopy(x)
			sNum = dProd .itsSerialNum() 
			if (sNum  is None) or sNum.IsBelow(
				self.parentToken.serialNum):
				dProd.setSerialNum(keyItem.serialNum)
				dProd.containerFile = self.containerFile
				addingTo.CombineProduction(dProd) 
				if (addingTo.containerFile not in
					Prod.ProdList.dirtyToRebuildFiles):
					Prod.ProdList.dirtyToRebuildFiles.append(
						addingTo.containerFile)
				action = 1

		if action == 1:
			Prod.minProdList.AddProd(addingTo)


	def GetRecursionLevel(self, defFields):
		l = 0
		newParent = self.parentToken
		while newParent is not None:
			if newParent.__str__() in defFields:
				l = l + 1
			newParent = newParent.parent

		return l


	#For parsing and expansion to verbose form
	def Tagas(self,defFields, forExpansion = 0):	
		#The tag cannot an expresss, it must a 'raw'string
		theTag = defFields[1]
		resStr = '<' + theTag
		#Don't allow closing tags - it can't be reconstructed
		for x in defFields[2:]:
			if '=' in x:
				x = Strip(x)
				splitArray = Split(x,'=',0)
				if(len(splitArray) == 1):
					if forExpansion:
							resStr = resStr + (' ' + x + ' ')
					else:
						resStr = (resStr + ' ' +
								  self.Eval(x)+ ' ')
				else:
					MyUtil.SyntaxRequire(
						splitArray[1]!='' and (splitArray[0]!=''))

					if forExpansion:
						resStr = (resStr + ' ' +
								  splitArray[0]
								  + '="' +
								  splitArray[1] + '"')
					else:
						resStr = (resStr + ' ' +
								  self.Eval(splitArray[0])
								  + '="' +
								  self.Eval(splitArray[1]) + '"')
			else:
				if forExpansion:
					resStr = resStr + (' ' + x + ' ')
				else:
					resStr = (resStr + ' ' +
							  self.Eval(x)+ ' ')
		resStr = resStr + '>'
		return resStr
	
	#We get one modification token,
	#Evaluate it according to the current context,
	#Then output the production with a '*' prepended to 
	#signify it's modification production
	def EmbedToken(self,defFields):
		insertStr = '*'
		commandStr = defFields[0]
		if commandStr[0] == '-':
			commandStr = commandStr[1:]
			insertStr = '-'
		elif commandStr[0] == '+': #Cause use replace entire production
			commandStr = commandStr[1:]
			insertStr = ''
		
		commandTok = self.EvaluateToken(
			MyUtil.SyntaxRequire(commandStr))
		theProd = MyUtil.SyntaxRequire(
			self.ProdFromToken(commandTok),'Missing Production'
			).ACopyOf()
		if len(defFields) > 1:
			contextToken = self.EvaluateToken(defFields[1])
			if contextToken.serialNum is not None:
				theProd.tokenList[0].serialNum = contextToken.serialNum
			else:
				theProd.tokenList[0].serialNum = self.itterSerialNum
				
			contextToken.tokenType = 'nt'
		else:
			contextToken = MyToken.Token('S')
			theProd.tokenList[0].serialNum = None

		theProd.DoSubstitution(self.parentToken,self)
		theProd.tokenList[0].stringOrList = insertStr + \
			contextToken.stringOrList
		theProd.tokenList[0].tokenType = 'nt'
	
		return theProd.__str__()
		#We get one modification token
	
	def SetDefinition(self, actionToken):
		defToken = self.parentToken
		if(defToken.parent is not None):
			defToken = defToken.parent 
		return self.DoDefinition(defToken, actionToken)
			
	def DoDefinition(self, defToken, actionToken):
		#This works like the other except the list
		#comes from a token instead of directly parsing
		#the delimiter
		defFields = actionToken.stringOrList 
		resToken = MyToken.Token()
		
		#go up a further level in doing definition
			
		if type(defFields[0]) == types.InstanceType:
			commandStr = defFields[0].ToBaseString()
		else:
			commandStr = defFields[0]
		
		commandStr = self.Eval(commandStr)
		
		if commandStr == "":
			return MyToken.Token()

		if commandStr != "" and (len(defFields) == 2):
			ItsSerialNum = None
			arg = string.strip(defFields[1].ToBaseString())

			if (string.upper(commandStr) ==
				string.upper('IsAdminOption')):
				return
				
			isAdmin = 0
			if string.lower(commandStr) == 'sessionkey':
				#pdb.Pdb().set_trace()
				theUserList = MyAdmin.UserList()
				if theUserList.VerifySessionKey(arg):
					isAdmin = 1
			
			if commandStr == 'maxparagraphlen':
				MyUtil.SyntaxRequire(
					MyUtil.IsStringNumber(arg))
				newValue = string.atoi(arg)
				MyUtil.MaxParagraphLength = newValue 
				return MyToken.Token()

			if(arg != '++' and (arg != '--')):			
				defFields[1].serialNum = ItemCopy(
					self.itterSerialNum)
				resToken = self.EvaluateToken(defFields[1])
				ItsDefinition = resToken.ToBaseString()
				ItsSerialNum = ItemCopy(resToken.serialNum)
				toSet = ItsDefinition 
				#Recursive expansion of nt variables
				#This can be avoid by using quotes to 
				#create a terminal token
				while (resToken.tokenType == 'nt' 
					and not 
					Prod.ProdList.theProdList.has_key(string.upper(toSet)) ):
					prevSet = toSet
					toSet = defToken.GetSetString(toSet,None,0)	
					MyUtil.SyntaxRequire(toSet != ItsDefinition,
						'Error circular definition')
					if toSet == "": 
						toSet = prevSet
						break
				ItsDefinition = toSet
			else:
				ItsDefinition = defFields[1]
			
			if isAdmin == 1:
				commandStr = 'AdminViewOption'
				ItsDefinition = '1'
			defToken.SetStringValues(
				commandStr,
				ItsDefinition ,
				ItsSerialNum)
		
		elif len(defFields) > 2:
			resList = []
			for x in defFields[1:]:
				y = self.Eval(x)
				resList.append(y)
			
			defToken.SetStringValues(
				commandStr,resList,
				self.itterSerialNum)
			
		return MyToken.Token()

	def LogicEval(self, defFields):
		#simple boolean logic for defined values
				
		#even indexes are 1st, 3rd since we start at 0
		FieldLen = len(defFields)
		for x in range(FieldLen):
			if(x%2==1 and self.GetExprTruthValue(
				defFields[x]
				)):
				res = defFields[x-1]
				if ((res[0] == "'" ) 
					and res[-1]== "'"):
					res = res[1:-1]
					return MyToken.Token(res,
							'terminal',
							self.itterSerialNum)
				else:
					return self.EvaluateToken(res)
			if(x == FieldLen-1):
				if (FieldLen-1)%2==1:
					return MyToken.Token()
				else:
					res = defFields[FieldLen-1]
				if (len(res) > 0 and 
					(res[0] == "'" ) 
					and res[-1]== "'"):
					res = res[1:-1]
					return MyToken.Token(res,
							'terminal',
							self.itterSerialNum)
				else:
					return self.EvaluateToken(res)
		assertBad

	def Concatnate(self, defFields):
		#concatinate strings, evaluate in opposite order!!!
				
		TotalString = ""
		for x in defFields:
			TotalString  = TotalString + self.FullyExpand(x)
	
		return MyToken.Token(TotalString,
						'terminal',
						self.itterSerialNum)
	
	def FullyExpand(self, tokString):
		tokenToExpand = self.EvaluateToken(tokString)
		tokenToExpand.serialNum = self.itterSerialNum
		tokenToExpand.SetAsParent(self.parentToken)
		return Prod.minProdList.ExpandToView(tokenToExpand)

		
	#A cross-product type opperation
	def ExtendByToken(self, defFields):
		if len(defFields) > 1:
			curExtensionToken = self.EvaluateToken(defFields[1])
			curExtensionString = curExtensionToken.ToBaseString() 
			proxyToken = self.Eval(defFields[0])
		else:
			curExtensionToken = self.EvaluateToken(defFields[0])
			curExtensionString = curExtensionToken.ToBaseString() 
			proxyToken = None
			
		if(self.extensionToken is not None):
			return self.extensionToken
		self.extensionString = curExtensionString 
		
		if(string.upper(curExtensionString) == 'NUM'):
			MyUtil.SyntaxRequire(len(defFields) > 1)
			index = self.EvalAsNumber(defFields[1])
			MyUtil.SyntaxRequire(index >= 0)
			theExtendList = []
			for i in range(index): 
				theExtendList.append( MyToken.Token('%d' % i))
		
		elif MyControl.pageLoader().IsCGIValue(curExtensionString):
			theExtendList = MyControl.pageLoader(
				).CgiHtmlBlockList(curExtensionString)
		
		else:
			theProd = MyUtil.SyntaxRequire(
				Prod.minProdList.ProdFromKey(curExtensionString,
						self.parentToken))
			theExtendList = theProd.tokenList[1:]

			theProd.SetKey(self.parentToken)
		
		if proxyToken is None:
			return self.ExtendByList(theExtendList,
				defFields[0])
		else:
			return self.ExtendByList(theExtendList,
						defFields[0],
						proxyToken)
	
	def ExtendByList(self, 
			extensionList, 
			extensionCommand,
			proxy = None):
		if not self.doAction:
			return MyToken.Token()
		#a cross product type opperation
		if(self.extensionToken is None):
			ProxyTok = None
			if proxy is not None:
				ProxyTok = MyToken.Token(proxy,'nt')
				ProxyTok.serialNum = ItemCopy(self.itterSerialNum)
			finalList = []
			
			for x in extensionList:
				if type(x) != types.InstanceType:
					finalList.append(MyToken.Token(x))
				else:
					finalList.append(x)
			
			self.extensionItter = \
				ProdItterator(
					MyToken.Token(finalList),
					self.parentToken,
					extensionCommand,
					ProxyTok
					)
			self.extensionItter.itterSerialNum = ItemCopy(self.itterSerialNum)
				
			self.extensionToken = \
					self.extensionItter.NextProd()
			self.extensionItter.CarryingOverDefines(self.extensionToken)

		
		if(self.extensionToken is not None):
			return self.extensionToken
		else:
			return MyToken.Token("")
	
	
	#Extend with a virtual production of sub-serial number tokens
	# 1. indexing token
	# 2. ProxyToken
	# 3. Subtoken as the sorting field 
	# - skip and assumeserialNum if a serialNumber value is used.
	# 4. Min value
	# 5. Max value
	# 6. Level of sorting - assumed to 1, can N, which means agregate subtrees,
	
	def IndexedSubtokens(self, defFields):
		theSearchSpec = SerialNumList.SearchSpecifier()
		self.ParseListIntoStructure(
			self.SplitDefFields(defFields),
			theSearchSpec)
		theSearchSpec.searchKey = defFields[0]
		if not theSearchSpec.baseNum:
			theSearchSpec.baseNum = ItemCopy(self.itterSerialNum)

		resList = None
		if theSearchSpec.cgi:
			resList = MyControl.pageLoader().CGISelectList(
				theSearchSpec.searchKey)

		if theSearchSpec.nestBy and (resList is None):
			resList = self.parentToken.GetSetString(defFields[0])
			if type(resList) != type([]):
				resList = None
		if resList is None:
			resList = Prod.minProdList.SublistFromKey(
				defFields[0],theSearchSpec)	
		
		if(len(resList) ==  0):
			return MyToken.Token()
		if theSearchSpec.exists:
			return MyToken.Token("1")
		if theSearchSpec.onlyGetOne:
			return resList[0]
		resTok = self.ExtendByList(resList,
					defFields[0], 
					theSearchSpec.proxy)
		return resTok
	
	#defines a serialNumber and token combo
	#in different, *OVER-LAPPING* ways
	def IndexSubstitution(self,defFields):
		isSubIndex = 0
		isSibIndex = 0
		isTerminal = 0
		if len(defFields) > 1:
			resString = defFields[0]
			toParse = defFields[1]
		else:
			resString = ''
			toParse = defFields[0]
		if len(toParse) > 0 and toParse[0] == '^':
				toParse = toParse[1:]
				isSubIndex = 1
		if len(toParse) > 0 and toParse[0] == '+':
				toParse = toParse[1:]
				isSibIndex = 1
		if len(toParse) > 0 and toParse[0] == "'":
				toParse = toParse[1:]
				isTerminal = 1
				
		newNum = None
		if toParse != '':
			parsedToken = self.EvaluateToken(toParse)
			newNum = MySerialNumber.SomeDecQuantity.ParseSerialNum(
				parsedToken.ToBaseString())
			if (newNum is None):
				newNum  = self.parentToken.GetSetSerialNum(
								parsedToken.ToBaseString())
			if ((newNum is None) and parsedToken.serialNum is not None 
				and (parsedToken.serialNum != self.itterSerialNum)):
				newNum  =  ItemCopy(parsedToken.serialNum)
		if newNum is None or (newNum.IsNull()): 
			newNum = ItemCopy(self.itterSerialNum)

		finalString = ''
		if newNum is not None and resString == '':
			finalString  = newNum.__str__()

		if isSubIndex:
			#Inherit serial number context from parent
			if resString== '':
				resString = self.parentToken.ToBaseString()
			newNum = Prod.minProdList.NextSerialNumAtBelow(
				resString,newNum)
			newNum = ItemCopy(newNum)

		if isSibIndex:
			#Inherit serial number context from parent
			if resString== '':
				resString = self.parentToken.ToBaseString()
			newNum = Prod.minProdList.NextSerialNumAtSib(resString,newNum)

		if finalString != '':
			resString = finalString
		
		if len(resString) > 0 and (resString[0] != "'"):
			resToken = MyToken.Token(resString,'nt',newNum)
			resToken = self.EvaluateToken(resToken)
			resToken.serialNum = newNum
		else:
			resToken = MyToken.Token(resString)
		
		if resToken.serialNum is None:
			resToken.serialNum = ItemCopy(newNum)
		if isTerminal:
			resToken.tokenType = 'terminal'
			
		return resToken

	#Pseudo because it isn't necesarrily added to ProdList yet
	def PseudoProd(self, defFields):
		pl = []
		file = None
		count = 0
		for x in defFields:
			resToken = None
			if x == '' and count == 0:
				resTok = MyToken.Token('S','nt')
			#Allow a litteral with a ` in it
			elif (x[0] == "'" and 
				(x[-1]) == "'"):
				resToken = self.EvaluateToken(x)
			
			elif (x[0] == "*" and 
				count == 0):
				resToken = MyToken.Token(
					'*' + self.Eval(x),'nt')

			elif x[0] == "^":
				cgiList = MyControl.pageLoader.CGISelectList(x[1:])
				if cgiList is not None:
					pl = pl + cgiList
					continue
				else:
					expandList = Prod.ProdFromKey(self.Eval(x[1:]))
					if expandList is not None:
						pl = pl + expandList.TokenList[1:]
						continue
					
			elif x[0] == "|":
				file = self.Eval(x[1:])
				continue
			
			elif "`" in x:
				#My split will still skip stuff in parens
				defineArray = Split(x,"`",0)
				if len(defineArray) > 1:
					keyToken = \
						self.EvaluateToken(defineArray[0])
					defToken = \
						self.EvaluateToken(defineArray[1])
					resToken = MyToken.Token([keyToken,
									defToken])
			if resToken is None:
				resToken = self.EvaluateToken(x)
			if count == 0:
				resToken.tokenType = 'terminal'
			pl.append(resToken)
			count = count + 1
		#end for x ...
		
		pProd = Production.Production(pl)
		if file is not None:
			pProd.containerFile = file
		return MyToken.Token(pProd)
	
	def ProdFromToken(self, theTok):
		if theTok.prodWithin is not None:
			return theTok.prodWithin
		else:
			return ItemCopy(Prod.minProdList.ProdFromKey(
					theTok))
		
	def SplitDefFields(self,defFields):
		defDic = {}
		for x in defFields:
			c = 0
			while c < len(x):
				if x[c] == ' ':
					defDic[
						string.upper(x[0:c])
						] = x[c+1:]
					break
				c = c+1
				if c == len(x): #if we're at the end
					defDic[string.upper(x[0:c])] = 1
		return defDic
	
	#Scan list 
	#We should be getting 
	#Values for each keys - so we know to get
	#values from the token if we can't find them in
	#the args
	def ParseListIntoStructure(self, defDic, object):
		#Take dictionary of characteristics
		#And turn it into a 
		keyList = object.__dict__.keys()
		for orgName in keyList:
			a = getattr(object,orgName)
			atName = string.upper(orgName)
			toSet = None
			x = None
			if (  type(a)!= type('')
				and type(a) != type(0)
				and type(a) != types.InstanceType):
				continue
			
			elif defDic.has_key(atName):
				x = defDic[atName ]
			else:
				fromDef = self.parentToken.GetSetString(
						atName)
				if fromDef != '':
					x = fromDef 
					
			if x is None:
				continue
				
			if type(a) == type(0):
				if type(x) == type(0):
					toSet = x			
				elif MyUtil.IsStringNumber(x):
					toSet =  string.atoi(x) 
				else:
					pVal = self.Eval(x)
					if MyUtil.IsStringNumber(pVal):
						toSet =  string.atoi(pVal) 
			
			elif (type(a) == type('')):
				toSet =  self.Eval(x)
			
			elif type(a) == type( types.InstanceType ):
				if (a.__class__ == 
					MySerialNumber.SomeDecQuantity.__class__):
					
					toSet = MySerialNumber.SomeDecQuantity.ParseSerialNum(x)
					
					if not toSet:
						return

				elif hasattr(a,'ACopyOf'):
					toSet = a.ACopyOf( self.Eval(x) )
				else:
					assertBad
			
			if toSet is not None:
				setattr(object,orgName,toSet)

	
if __name__ == '__main__':
    test()


