#Crucial Questions Better BBS 
#Copyright 1998-1999 

#These classes read, interpret, add and write 
#'productions'

import os
#import dircache
import Mycgi #cgi tweeked for non-unix systems 
import regex
import regsub
import string
import copy
import pdb
import profile
import pickle
import types

#import Prod
import ProdItterate
import MyUtil
from MyUtil import *

global PROD_DELIM 
PROD_DELIM = ','

class Production:
	def __init__(self,
		itsList= None, 
		ProdFile = MyUtil.baseFileName ):
		self.tokenList = []
		if itsList is not None:
			for x in itsList:
				self.tokenList.append(x)
		self.containerFile = ProdFile
		self.isNew = 0 #New meaning being created right now, normally 

	def IsDynamic(self):
		return self.containerFile == MyUtil.DynaTextName

	def DoSubstitution(self,contextToken,contextItter):
		for x in self.tokenList:
			x.DoSubstitution(contextToken,contextItter)
	
	def ACopyOf(self):
		import MyToken
		theNew = Production()
		theNew.tokenList = MyToken.RecursiveCopy(self.tokenList)
		theNew.containerFile = self.containerFile
		theNew.isNew = self.isNew
		return theNew

	def ItsKey(self):
		import MyToken
		if(len(self.tokenList ) != 0):
			if type(self.tokenList[0]) == types.InstanceType:
				res = self.tokenList[0].stringOrList
				res = string.upper(res)
				res = string.strip(res)
				return res
		return ""
	
	def ItsSerialNum(self):
		import MyToken
		if(len(self.tokenList ) != 0):
			if type(self.tokenList[0]) == types.InstanceType:
				itsNum = ProdItterate.ItemCopy(
					self.tokenList[0].serialNum)
				return itsNum
		return None
	
	def SetKey(self,newKeyToken):
		self.tokenList[0] = newKeyToken
	
	def SetSerialNum(self,serialNum):
		import MyToken
		if(len(self.tokenList ) != 0):
			if (type(self.tokenList[0])
				== types.InstanceType):
				self.tokenList[0].serialNum = \
					ProdItterate.ItemCopy(serialNum)
		return None

	#let exception do our error checking
	#this is key to proper parent child relations

	#Prod's __str__ function is for saving, not display
	def __str__(self):
		result = '['
		if len(self.tokenList) > 0 :
			keyToken = self.tokenList[0]
			result = result + keyToken.__str__(0,1)
			if keyToken.serialNum is not None:
				result = result + keyToken.serialNum.__str__()
			
		for i in range(1,len(self.tokenList)):
			curItem = self.tokenList[i]
			result = result + "," + self.showSubitem(curItem)
			
		if(result[len(result)-1] == PROD_DELIM):
			result = result[0:len(result)-1] +  ']' 
		else:
			result = result + ']'	
		return result
	
	def showSubitem(self,item):
		import MyToken
		if type(item) == type(''):
			return item		
		elif type(item) == types.InstanceType:
			return item.__str__(0) 		
		elif type(item) == type([]):
			string = '[ '
			for j in item:
				string = string + self.showSubitem(j) + PROD_DELIM
			string = string[:-1] #eat the last comma
			string = string + ']'
			return string

	#This places the prod within an stream of text
	def AsHtmlFragment(self):
		theKey = self.tokenList[0].__str__(1,1)
		if self.tokenList[0].serialNum is not None:
			theSerialKey = (ProdBaseSerialNumName + '="' +self.tokenList[0
						].serialNum.__str__()+ '"')
		else:
			theSerialKey = ""
		
			
		#Add some carraige returns to make the HTML readable
    		
		return  ('\n'+'<' + bbsEmbedProdTag + ' '+
				ProdBaseTokenName +'="' +
				theKey + '" ' + '\n'+
				bbsEmbedProdMethodName + '="'
				+ 'expand" '+ theSerialKey +'>' 
					+ self.AsHtmlStream() 
				+'</' + bbsEmbedProdTag  + '">\n')
		

	def AsHtmlStream(self,showSubItems = 0,asBase = 0):
		result = ""
		if asBase:
			result = result + self.KeyAsTag()
		for i in range(1,len(self.tokenList)):
			curItem = self.tokenList[i]
			addStr = self.showFileSubitem(curItem,showSubItems)
			result = result + addStr 
		return result
	
	def showFileSubitem(self,item,showSubItems):
		if item.tokenType == 'terminal':
			outChars = item.__str__(1,1)
			return outChars
		elif not showSubItems:
			return item.AsSubTag()
		elif type(item.stringOrList) == type([]):
			return item.AsSubTag()

		codeString = theToken.ToBaseSting()
		if codeString[0] in token_commands:
			return item.AsSubTag()
		
		theProd = ProdList().ProdFromKey(codeString)
		if theProd is None:
			return item.AsSubTag()
		else:
			return theProd.AsHtmlFragment(0)
		

	def KeyAsTag(self):
		sn = self.ItsSerialNum()
		if sn is not None:
			ss = ProdBaseSerialNumName + '="' + \
				sn.__str__() + '" '
		else: ss = ''
		
		return ('<' + bbsProdNameTag + ' '+\
			   ProdBaseTokenName + '="' +
				self.ItsKey() + '" ' + ss +'>')

	def DoProd(self):
		import MyToken
		prodItter = ProdItterate.ProdItterator(
					MyToken.Token(
						self.tokenList[1:]),
					self.tokenList[0]
					)
		prodItter.itterSerialNum = ProdItterate.ItemCopy(self.ItsSerialNum())
		prodItter.containerFile = self.containerFile 
		return prodItter.DoProd()
	
	def CombineProduction(self,modProd):
		import MyToken
		index = 1
		if (self.IsDynamic() and modProd.IsDynamic()):
			reseting = 1
		else: reseting = 0
		
		if len(self.tokenList) <= 1:
			self.tokenList = MyToken.RecursiveCopy(modProd.tokenList)
		
		while index < len(modProd.tokenList):
			modToken = modProd.tokenList[index]
			if not modToken.IsTransform():
				self.tokenList.append(modToken.ACopyOf())	
			else:
				actOn = 0
				for i in range(1,len(self.tokenList)):
					if (self.tokenList[i].IsTransform() and 
						(modToken.Key() == 
							self.tokenList[i].Key())): 
						actOn = 1
						#If it does nothing
						if (modToken.Map() 
							== self.tokenList[i].Map()):
							#if reseting:
								#delete modProd.tokenList[index]
							#	modProd.tokenList = \
							#	(modProd.tokenList[:index] +
							#		modProd.tokenList[
							#			index+1:])
							#	i = i - 1
							pass
						else:
							self.tokenList[i].SetMap( 
								modToken.Map())
				if not actOn:
					self.tokenList.insert(1, modToken.ACopyOf())
			index = index + 1
	
	#def FirstToken(self):
	#	if (len(self.tokenList) > 1 
	#		and type(self.tokenList[1]) 
	#		==types.InstanceType):
	#		prodItter = ProdItterate.ProdItterator(
	#					MyToken.Token(
	#						self.tokenList[1:]),
	#					self.tokenList[0]
	#					)
	#		prodItter.itterSerialNum = self.ItsSerialNum()
	#		prodItter.containerFile = self.containerFile 
	#		return prodItter.NextProd(0)
	#	else:
	#		MyUtil.errorLog.append(
	#			'Zero-length Prod with' + self.tokenList[0].__str__() )

	def FirstStringToken(self):
		import MyToken
		if (len(self.tokenList) > 1 
			and type(self.tokenList[1]) 
			==types.InstanceType):
			prodItter = ProdItterate.ProdItterator(
						MyToken.Token(
							self.tokenList[1:]),
						self.tokenList[0]
						)
			prodItter.itterSerialNum = self.ItsSerialNum()
			prodItter.containerFile = self.containerFile 
			res = MyToken.Token()
			found = 0
			while (not res):
				res = prodItter.NextProd(0)
				
				if res is None:
					return MyToken.Token()
			return res
	
	def KeyValue(self,theString):
		for x in self.tokenList[1:]:
			if x.IsTransform():
				if x.Key() == string.upper(theString):
					return x.Map()
		return ""
