#Crucial Questions Better BBS 
#Copyright 2000 Hans Joseph Solbrig
#
#See License Agreement in distribution

import os
import dircache
import Mycgi #cgi tweeked for non-unix systems
import regex
import regsub
import string
import copy
import pdb
import profile

import MySerialNumber
import MyUtil

from string import *

#This is used to find productions
#In SerialNumList
class SearchSpecifier:
	occurLimitToks = {}
	def __init__(self):
		self.searchKey = ""
		self.levelsDown = 1
		self.start = MySerialNumber.DecQuantity()
		self.end = MySerialNumber.DecQuantity()
		self.proxy = ""
		self.baseNum = MySerialNumber.DecQuantity()
		self.fromEnd = 0
		self.numToGet = MySerialNumber.DecQuantity()
		self.exists = 0
		self.returnSerialNum = 0
		self.onlyAtOneLevel = 0
		self.onlyGetOne = 0
		self.nestBy = ''
		self.sortBy = ''
		self.returnSortField = 0
		self.numToGet = -1
		self.cgi = 0
		self.putNulls = 'nowhere'
		self.limitOccuranceBy = ''

	def AsStandAlone(self,theToken):
		theDefault = SearchSpecifier()
		result = ""
		for x in theDefault.__dict__.keys(x):
			if self.__dict__[x] != theDefault.__dict__[x]:
				result = result + '%' + x + ' ' + \
						 ObjectAsstring(self.__dict__[x])
		return Token(result,'appender')

	#This function uses the limiter indepently of the
	#instance search specifier
	def TestAndAdd(self, item, index):
		if (self.baseNum and
			not self.baseNum.IsBelow(item)):
			return 0

		if ((self.start) and
			index < searchSpec.start):
			return 0

		if ((self.end) and
			index > searchSpec.end ):
			return 0

		if self.limitOccuranceBy == '':
			return 1
		if SearchSpecifier.occurLimitToks.has_key(
				self.limitOccuranceBy):
			if (SearchSpecifier.occurLimitToks[
				self.limitOccuranceBy].has_key(item.__str__())):
				return 0
			else:
				SearchSpecifier.occurLimitToks[
				self.limitOccuranceBy][item.__str__()] = 1

		else:
			Dict = {}
			Dict[item.__str__()] = 1
			SearchSpecifier.occurLimitToks[
				self.limitOccuranceBy] = Dict 

		return 1

	

#List of DecQuantity Items
class QuantList:
	def __init__(self):
		
		self.valuesSet = 0
		self.quantityIndex = None 
		self.indexAt = None
		
		self.prevSib = None #set by parent, not the itself object
		self.nextSib = None #set by parent, not the itself object
		
		self.firstChild = None
		self.lastChild = None
		self.parent = None
		
		self.sublistIndex = {}
		
		#object at node
		self.oldValues = []
		self.childCount = 0

	def setValueAt(self,toSet):
		self.valuesSet = 1
		MyUtil.Assert(toSet is not None)
		self.theRealValue = toSet
	
	def getValueAt(self):
		if self.valuesSet:
			MyUtil.Assert(self.theRealValue is not None)
			return self.theRealValue 
		else:
			return None

	#Begin UserDict
	def __len__(self): return self.childCount
	def __getitem__(self, key):
		if type(key) != MySerialNumber.TheDecQuantityType:
			key = MySerialNumber.SomeDecQuantity.ParseSerialNum(
				key)
		return self.At(key)
	def __setitem__(self, key, item):
		if type(key) != MySerialNumber.TheDecQuantityType:
			key = MySerialNumber.SomeDecQuantity.ParseSerialNum(key)
		self.Add(key,item)
	def __delitem__(self, key):
		self.RemoveAt(key) 
	def keys(self): 
		a = self.AllChildrenAt()
		cl = []
		for x in a:
			cl.append(x[0])
			
	def items(self): 
		a = self.AllChildrenAt()
		cl = []
		for x in a:
			cl.append((x[0],x[1]))

	def values(self):
		a = self.AllChildrenAt()
		cl = []
		for x in a:
			cl.append(x[0])
	def has_key(self, key):
		return self.NodeAt(key) is not None

	#End UserDict	
	
	#this requires "pointer-like" effects
	#false if adding new, true if replacing
	#
	#Might be spend up by finding a node first and adding
	#To that node
	def Add(self, quant, object,callingQuant = None):
		MyUtil.Assert(object is not None)
		MyUtil.Assert(quant is None or 
			type(quant) == MySerialNumber.TheDecQuantityType)
		
		#Add always should work, so we should always have
		#one more child. 
		self.childCount = self.childCount + 1
		
		#So each child knows the path all the way to the parent
		if callingQuant is None:
			if quant is not None:
				baseQuant = quant.ACopyOf()
			else:
				baseQuant = None
		else:
			baseQuant = callingQuant.ACopyOf()
		
		if quant is None or quant.IsNull():
			MyUtil.Assert(object is not None)
			#oldValue = self.getValueAt()
			#if self.getValueAt() is not None:
			#	self.oldValues.append(self.getValueAt())
			if baseQuant is not None:
				self.indexAt = baseQuant.ACopyOf()
			else:
				self.indexAt = None
			self.setValueAt(object)
			return 
		
		MyUtil.Assert(len(quant.__str__()) > 0)
		keyStr = quant.Rep().__str__()
		remainder = quant.Decimal()
		if (self.sublistIndex.has_key(keyStr) ):
			subNode = self.sublistIndex[keyStr]
			subNode.Add(remainder,object,baseQuant)
		else:
			newChild = QuantList()
			newChild.quantityIndex = quant.Rep()
			newChild.parent = self
			
			if newChild.parent.quantityIndex is None:
				newChild.indexAt = baseQuant.Rep()
			else:
				newChild.indexAt = MySerialNumber.DecQuantity(
							self.indexAt,
							quant.Rep())
			newChild.Add(remainder, object, baseQuant)
			MyUtil.Assert( (not remainder.IsNull() ) or
				(newChild.getValueAt() is not None) )
			
			MyUtil.Assert(
				self.lastChild is None or (
					quant.Rep() != self.lastChild.quantityIndex or 
					quant.Rep() != self.firstChild.quantityIndex ))
			
			bigPart = quant.Rep() 
			if(self.lastChild is None):
				self.lastChild = newChild
				self.firstChild = newChild
			elif (bigPart > self.lastChild.quantityIndex ):
				newChild.prevSib = self.lastChild
				(self.lastChild).nextSib = newChild
				self.lastChild = newChild
			
			elif (bigPart < self.firstChild.quantityIndex  ):
				newChild.nextSib = self.firstChild
				(self.firstChild).prevSib = newChild
				self.firstChild = newChild
				
			else:
				counter = self.lastChild #count down
				while (bigPart < counter.quantityIndex ):  
					MyUtil.Assert(counter.quantityIndex 
								!= bigPart)
					oldCount = counter
					counter = counter.prevSib
				newChild.nextSib = oldCount
				newChild.prevSib = counter
				counter.nextSib = newChild
				oldCount.prevSib = newChild
					
			self.sublistIndex[bigPart.__str__()] = newChild
			return None
	
	def RemoveAt(self, quant):
		lastDecimal = quant.lastDecimal()
		nodeAt = self.NodeAt(quant.Parent())
		if nodeAt is not None: 
			success = nodeAt.RemoveChildNode(lastDecimal)
			return success
		return 0

	def RemoveChildNode(self,quant):
		MyUtil.Assert( type(quant)==MySerialNumber.TheDecQuantityType )
		if( quant is None or quant.Rep() is None):
			return 0
		
		keyStr = quant.__str__()
		if (self.sublistIndex.has_key(keyStr) ):
			subNode = self.sublistIndex[keyStr]
			del self.sublistIndex[keyStr]
			self.childCount = self.childCount - 1
			beforeNode = subNode.prevSib
			afterNode = subNode.nextSib
			
			if beforeNode is not None:
				if afterNode is not None:
					afterNode.prevSib = beforeNode
					beforeNode.nextSib = afterNode
				else:
					#We're at the last with children
					beforeNode.nextSib = None
					self.lastChild = beforeNode
			else:
				if afterNode is not None:
					#We're at the first with children
					afterNode.prevSib = None
					self.firstChild = beforeNode
				else:
					self.lastChild = None
					self.firstChild = None
			return 1
		return 0
		
	
	def At(self,quant):
		node = self.NodeAt(quant)
		if node is not None: 
			if node.getValueAt() == "Not Set":
				return None
			else:
				return node.getValueAt() 
		return None
	
	#Includes
	def AllChildrenAt(self,theSerialNum):
		node = self.NodeAt(theSerialNum)
		if node is not None: 
			return node.AllChildren()
		return - 1

	def AllChildren(self):
		v = self.getValueAt() 
		if self.getValueAt() != None:
			childList = [[(self.indexAt),v]]
		else:
			childList = []
		for x in self.sublistIndex.keys():
			childList = childList + \
					self.sublistIndex[x].AllChildren()
		return childList
		

	def childCountAt(self,quant):
		node = self.NodeAt(quant)
		if node is not None: 
			return node.childCount
		return - 1
	
	def NodeAt(self,quant):
		if quant is None or quant.IsNull():
			return self
		else:
			if(self.sublistIndex.has_key(quant.Rep().__str__()) ):
				return \
					self.sublistIndex[quant.Rep().__str__()].NodeAt(
									quant.Decimal())
			else:
				return None
	
	#Itteration system, itterates all but the top parent
	#First the parent, then the children, 
	#then the next parent

	def AsList(self):
		theList = []
		listItter = self.NextItteration([None,None])
		
		while listItter is not None:
			anItem = listItter[1]
			theList.append(anItem)
			listItter = self.NextItteration(
				listItter)

		return theList

	
	def NextItteration(self,index):
		res = self.NodeAt(index[0])
		#Since we're itterating, this res should never be none
		res = res.NextInSequence()
		if res is None: 
			return None
		curValue = res.getValueAt()
		while res is not None and (curValue is None):
			res = res.NextInSequence()
			if res is None:
				return None
			curValue = res.getValueAt()
	
		return ([res.indexAt,
				curValue,res.oldValues])

	
	def NextInSequence(self):
		if self.firstChild is not None:
			return self.firstChild
		else: 
			if self.nextSib is not None:
				return self.nextSib
		
		#Now go all the way to the top
		parentCounter = self.parent
		while 1:
			if parentCounter is None:
				return None
			if parentCounter.nextSib is not None:
				return parentCounter.nextSib
				
			parentCounter = parentCounter.parent
	
	def ChildListAt(self, searchSpec):
		nodeAt = self.NodeAt(searchSpec.baseNum)
		if nodeAt is not None:
			return nodeAt.ChildList(searchSpec)
		return None
	
	def ChildList(self,searchSpec):
		if not searchSpec.fromEnd:
			counter = self.firstChild 
		else:
			counter = self.lastChild
		numCount = 0
		accumulator = []
		if searchSpec.start:
			while counter is not None and (
				(counter.quantityIndex  < searchSpec.start)):
				if not searchSpec.fromEnd:
					counter = counter.nextSib
				else:
					counter = counter.prevSib
		
		while (counter is not None and 
			((not searchSpec.end) or 
			 (counter.quantityIndex  <= searchSpec.end) )): 
			toAddTo = counter.getValueAt()
			if (toAddTo is not None and 
				(searchSpec.occurLimitToks =='' or 
					searchSpec.TestAndAdd(counter.indexAt,
										  counter.quantityIndex))):
				accumulator.append(toAddTo)
				numCount = numCount + 1
				if (searchSpec.onlyGetOne or 
					searchSpec.exists):
					return accumulator
				if (searchSpec.numToGet > 0 
					and (numCount > searchSpec.numToGet)):
					return accumulator[0:searchSpec.numToGet]
				
			#we get everything at each level
			if searchSpec.levelsDown > 1:
				newSpec = copy.copy(searchSpec)
				#Limit amount from subList to how many we want
				if searchSpec.numToGet > 0:
					newSpec.numToGet = \
						searchSpec.numToGet - numCount
				newSpec.levelsDown = searchSpec.levelsDown - 1
				accumulator = accumulator + \
					counter.ChildList(newSpec)
			
			if not searchSpec.fromEnd:
				counter = counter.nextSib
			else:
				counter = counter.prevSib
		
		return accumulator
	
	def NumberBelowAfter(self):

		if self.lastChild is not None:
			c = self.lastChild.indexAt.ACopyOf()
			if (len(c.listRep)>0
				and len(c.listRep[-1]) > 0):
				c.listRep[-1] = [ c.listRep[-1][0] + 1 ]
				result = c
			else:
				c.listRep = [[0]]
				result = c
		else:
			if self.indexAt is not None:
				result = self.indexAt.BeginSub()
			else:
				result = MySerialNumber.DecQuantity(0)
		
		return result
	
	def NextNumberBelow(self,subIndex):
		#if subIndex is None:
		#	return MySerialNumber.DecQuantity(0)
		SubNode = self.NodeAt(subIndex)
		if SubNode is None:
			return subIndex.BeginSub()
			
		return SubNode.NumberBelowAfter()
	
	## This will be supplemented by a search criteria at sum point
	def NumberBelowAt(self, subIndex):
		subNode = self.NodeAt(subIndex)
		if subNode is None:
			return None
		if subNode.firstChild is None:
			return None
		firstValued = subNode.firstChild
		while firstValued is not None:
			if firstValued.getValueAt() != 'Not Set':
				return firstValued.indexAt 
			firstValued = firstValued.nextSib
		return None
	
	def NumberSiblingAt(self, subIndex):
		subNode = self.NodeAt(subIndex)
		if subNode is None:
			return None
		if subNode.nextSibling is None:
			return None
		firstValued = subNode.nextSib
		while firstValued is not None:
			if firstValued.getValueAt() != 'Not Set':
				return firstValued.indexAt 
			firstValued = firstValued.nextSib
		return None
		
	def PrevNumberBelow(self,subIndex):
		SubNode = self.NodeAt(subIndex)
		return SubNode.NumberBelowBefore()

	#This gives us the next number to insert within an existing sequence
	#assume non-None index
	def NumberAfterInsert(self,subIndex):
		SubNode = self.NodeAt(subIndex)
		
		if SubNode.nextSib is None:
			return subIndex.indexAt.Next()
		else:
			return SubNode.indexAt.Between(
						SubNode.nextSib.indexAt)

	#assume non-None index
	def NumberBeforeInsert(self,subIndex):
		SubNode = self.NodeAt(subIndex)
		if SubNode.prevSib is None:
			return subIndex.Prev()
		else:
			betweenNum = SubNode.indexAt.Between(
						SubNode.prevSib.indexAt)
			return betweenNum 		
	
		
		#gives us an approximate view of the structure.
	def ll_Diagnosticf(self):
		if self.firstChild is not None:
			i = self.firstChild
			while i is not None:
				i.ll_Diagnosticf()
				i = i.nextSib

	def ll_Diagnosticb(self):
		
		if self.lastChild is not None:
			i = self.lastChild
			while i is not None:
				i.ll_Diagnosticb()
				i = i.prevSib
				
	def __str__(self):
		res = ''
		if self.getValueAt() is not None:
			if type(self.getValueAt()) == type(""):
				res  = res + self.getValueAt()
			else:
				res  = res + self.getValueAt().__str__()
		if self.firstChild is not None:
			i = self.firstChild
			while i is not None:			
				res = res + i.quantityIndex.__str__()				
				res = res + ':'				
				res = res + '{'
				if i.getValueAt() is None:
					res = res + 'None'
				elif type(i.getValueAt()) == type(""):
					res = res + i.getValueAt()
				else:
					res = res + i.getValueAt().__str__()
				res = res + ':' + i.__str__()
				res = res + '}'
				res = res + '\n'
				i = i.nextSib

		return res 
	
	#First XXXX - everything four levels deep.
	#Then 4567XXXX everything eight deep starting
	#With 4567, and so-forth.
	def CoveringSets(self, coveringLevels):
		for x in self:
			pass
			
	def theCoveringSet(self, serialNum):
		for x in self:
			pass

			
